import { Boton } from "componentes/boton";
import { Campo } from "componentes/campo";
import { Bloque } from "componentes/bloque";
import { DatosAlmacen } from "Movimientos/Shared/modelos/DatosAlmacen";
import { Pantalla } from "componentes/pantalla";
export declare class BloqueOrigen {
    _botonConsulta: Boton;
    _inputAlmacen: Campo;
    _inputUbicacion: Campo;
    _inputLote: Campo;
    _botonConsultaAlmacen: Boton;
    _bloqueOrigenUbicacion: Bloque;
    _bloqueOrigenLote: Bloque;
    _datosOrigen: DatosAlmacen;
    _PantallaPadre: Pantalla;
    constructor(Padre: Pantalla);
    onUpdateCallBack(fn: Function): void;
    get Datos(): DatosAlmacen;
    set Datos(value: DatosAlmacen);
    inicializaComponentes(): {
        _botonConsulta: import("componentes/boton").DefinicionBoton;
        _inputAlmacen: import("componentes/campo").DefinicionCampo;
        _botonConsultaAlmacen: import("componentes/boton").DefinicionBoton;
        _bloqueOrigenUbicacion: import("componentes/bloque").DefinicionBloque;
        _bloqueOrigenLote: import("componentes/bloque").DefinicionBloque;
        _inputUbicacion: import("componentes/campo").DefinicionCampo;
        _inputLote: import("componentes/campo").DefinicionCampo;
    };
    Inicializa(): void;
    set Articulo(value: string);
    set Almacen(value: string);
    set ControlLotes(Lotes: 'S' | 'N');
    set ControlUbicaciones(Ubicaciones: 'S' | 'N');
    actualizaVista(): void;
    actualizaBloque(): void;
    DeshabilitarCampos(): void;
    HabilitarCampos(): void;
    actualizaModelo(): void;
    ValidarUbicacionLote(): Promise<boolean>;
    ConsultaDatos(): Promise<boolean>;
    ObtenerLotesArticuloAlmacen(): Promise<[{
        GAUBIC_COD: string;
        LOTE: string;
        C_UNID1: string;
    }]>;
    ValidarUbicacion(): Promise<boolean>;
    ValidarAlmacen(): Promise<boolean>;
    ObtenerAlmacenesActivos(): Promise<{
        COD: string;
        DESCRIP: string;
    }[]>;
    ConsultaAlmacen(): Promise<boolean>;
    GestionaUbicacionDefecto(): Promise<void>;
    UbicacionDefecto(): Promise<{
        GAUBIC_DEF: string;
    }>;
}
