import { Boton } from "componentes/boton";
import { Campo } from "componentes/campo";
import { BloqueDestino } from "Movimientos/Shared/_BloqueDestino";
import { BloqueOrigen } from "Movimientos/Shared/_BloqueOrigen";
import { CambioUbicacionModel } from "Movimientos/modelos/cambio-ubicacion";
import { Pantalla } from "componentes/pantalla";
import { TipoMovimiento } from "Movimientos/modelos/tipo-movimiento";
export declare class PantallaCambioUbicacion extends Pantalla {
    _botonNuevo: Boton;
    _botonGuardar: Boton;
    _botonConsultaAlmacenOrigen: Boton;
    _botonConsultaAlmacenDestino: Boton;
    _inputArticulo: Campo;
    _inputArticuloDescipcion: Campo;
    _inputCantidad: Campo;
    _bloqueDestino: BloqueDestino;
    _bloqueOrigen: BloqueOrigen;
    _model: CambioUbicacionModel;
    constructor();
    inicializaComponentes(): {
        _botonNuevo: import("componentes/boton").DefinicionBoton;
        _botonGuardar: import("componentes/boton").DefinicionBoton;
        _inputArticulo: import("componentes/campo").DefinicionCampo;
        _inputArticuloDescipcion: import("componentes/campo").DefinicionCampo;
        _inputCantidad: import("componentes/campo").DefinicionCampo;
    };
    Inicializa(): void;
    actualizaVista(): void;
    actualizaModelo(): void;
    CambioArticulo(Articulo: string): Promise<void>;
    ValidarArticulo(Articulo: any): Promise<{
        GAART_COD: string;
        DESCRIP: string;
        UBIC_SN: 'S' | 'N';
        LOTES_SN: 'S' | 'N';
        GAUNITIP_COD: string;
    }>;
    CambioCantidad(): Promise<void>;
    ObtenerDatosCambioUbicacion(): Promise<{
        GAMOVTIP: TipoMovimiento[];
        GAALMNOM_ORI: string;
        GAALMNOM_DES: string;
    }>;
    Confirmar(): Promise<boolean>;
    BuscarCodigosAlternativos(Articulo: string): Promise<string>;
}
