import { Pantalla } from 'componentes/pantalla';
import { Boton } from 'componentes/boton';
import { Campo } from 'componentes/campo';
import { Tabla } from 'componentes/tabla';
import { Pedido, PedidoPreparado } from 'Recepcion/modelos/pedido';
import { DatosPantalla } from 'Recepcion/modelos/pantalla_modelo';
import { PedidoLinea } from 'Recepcion/modelos/pedido_linea';
import { Albaran } from 'Recepcion/modelos/albaran';
import { Bloque } from 'componentes/bloque';
export declare class PantallaRecepcion extends Pantalla {
    _botonNuevo: Boton;
    _botonConfirmar: Boton;
    _inputPedido: Campo;
    _inputReferencia: Campo;
    _inputCantidad: Campo;
    _bloqueReferencia: Bloque;
    _tabla: Tabla<PedidoLinea>;
    protected _DatosPantalla: DatosPantalla;
    protected _Pedido: Pedido;
    protected _PedidoPreparado: PedidoPreparado;
    protected _LineaSeleccionada: PedidoLinea;
    constructor();
    protected asociaComponentes(): void;
    actualizaVista(): void;
    actualizaModelo(): void;
    protected inicializa(): void;
    protected inicializaComponentes(): {
        _botonNuevo: import("componentes/boton").DefinicionBoton;
        _botonConfirmar: import("componentes/boton").DefinicionBoton;
        _inputPedido: import("componentes/campo").DefinicionCampo;
        _inputReferencia: import("componentes/campo").DefinicionCampo;
        _inputCantidad: import("componentes/campo").DefinicionCampo;
        _bloqueReferencia: import("componentes/bloque").DefinicionBloque;
        _tabla: import("componentes/tabla").DefinicionTabla<PedidoLinea>;
    };
    protected nuevo(): void;
    ObtenerPedido(): Promise<void>;
    ObtenerAlbaranes(): Promise<Albaran>;
    CambiarReferencia(): Promise<boolean>;
    BuscarReferenciaEnTabla(Articulo: string): PedidoLinea[];
    BuscarCodigosAlternativos(Articulo: string): Promise<PedidoLinea[]>;
    seleccionLinea(item: PedidoLinea): Promise<void>;
    private ActualizaCantidadesPedido;
    protected actualizaPreparadoArticuloSinLotesNiUbicaciones(pValor: number): Promise<void>;
    ObtenerDatosAdicionalesAlbaran(): Promise<void>;
    recepcionar(): Promise<void>;
}
