﻿define('expedicion-expedicion', ['expedicion-base'],
    function (Expedicion) {

        Expedicion.prototype.Expedir = function () {
            this./*exp*/SeleccionTransporte();
        };

        Expedicion.prototype.GestionarImpresionPendiente = function () {
            var AlbFn = (function () {
                this./*exp*/ExpedirFn();
                closeModal("#dialogLoV");
            }).bind(this);
            var EtiqFn = (function () {
                this./*exp*/ImprimirFn();
                closeModal("#dialogLoV");
            }).bind(this);

            var btnFunctions = function () {
                $("#btnPHAlb").on("click", AlbFn);
                $("#btnPHEtiq").on("click", EtiqFn);
            };
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var buttons = [
                generateSingleButton("btnPHAlb", "Albarán", "pull-right", "default"),
                generateSingleButton("btnPHEtiq", "Alb. + Etiq.", "pull-left", "gray")
            ];
            var Mensaje = "Se está dejando el albarán en estado PENDIENTE. \n \
    ¿Desea imprimir etiquetas o solo el albarán?";
            generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, Mensaje);
        };


        Expedicion.prototype.ImprimirExpedicion = function () {
            this./*exp*/DatosEnvio();
            //Recoger datos restantes de expedición
            this./*exp*/v_orden_exp['GGMENVIO_COD'] = $('#codTransporte').val();
            this./*exp*/v_orden_exp['GGVEHICULO_COD'] = $("#codVehiculo").val();
            this./*exp*/TransformExpedicion();
            this./*exp*/v_orden_exp.N_BULTOS = $('#bultosInput').val();
            this./*exp*/v_orden_exp.N_ETIQUETAS = $('#etiquetasInput').val();
            this./*exp*/v_orden_exp.PESO = $('#pesoInput').val();
            this./*exp*/v_orden_exp.OPCION_ETIQUETAS = $(this./*exp*/selectType).val();
            this./*exp*/v_orden_exp.ImprimirValorado = $(this./*exp*/chkAlbaranVal).is(':checked');
            this./*exp*/v_orden_exp.N_COPIAS = this./*exp*/DejarPendiente ? $('#CopiasInput').val() : null;


            //Params Expedir
            if (this./*exp*/DejarPendiente)
                this./*exp*/GestionarImpresionPendiente();
            else
                this./*exp*/ImprimirFn();
        };

        Expedicion.prototype.ExpedirFn = function () {
            //Params
            var url = "expedicion/Expedir";
            var data = this./*exp*/v_orden_exp;
            var method = "POST";
            var success = (function (response) {
                if (response.Ok) {
                    var GGALBTIP_COD = response.Objeto.GGALBTIP_COD;
                    var N_ALBARAN = response.Objeto.N_ALBARAN;
                    if (response.Objeto.PREGUNTA_HIST) {
                        var acceptFn = (function () {

                            var url = "/Expedicion/PonerHistorico";
                            var method = "POST";
                            var data = {
                                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                emp_cod: sessionStorage.getItem("EMPR_COD"),
                                GGPEDTIP_COD: this./*exp*/v_orden_exp.GGPEDTIP_COD,
                                N_PEDIDO: this./*exp*/v_orden_exp.N_PEDIDO
                            };
                            var success = function (response) {
                                var ok = (function () {
                                    closeModal('#dialogEnviosEtiquetas');
                                    closeModal("#dialogLoV");
                                    this./*exp*/Clear();
                                }).bind(this);
                                var error = function () {

                                };
                                if (response.Ok) {
                                    lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                                } else {
                                    lanzarMensaje(false, response.Mensaje, error);
                                }
                                //handleResponse(response, ok, error);
                            };
                            apiGeneral(url, method, data, success);
                        }).bind(this);
                        var cancelFn = (function () {
                            var url = "/Expedicion/DejarActivo";
                            var method = "POST";
                            var data = {
                                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                emp_cod: sessionStorage.getItem("EMPR_COD"),
                                GGPEDTIP_COD: this./*exp*/v_orden_exp.GGPEDTIP_COD,
                                N_PEDIDO: this./*exp*/v_orden_exp.N_PEDIDO
                            };
                            var success = function (response) {
                                var ok = (function () {
                                    closeModal('#dialogEnviosEtiquetas');
                                    closeModal("#dialogLoV");
                                    this./*exp*/Clear();
                                }).bind(this);
                                var error = function () {

                                };
                                if (response.Ok) {
                                    lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                                } else {
                                    lanzarMensaje(false, response.Mensaje, error);
                                }
                                //handleResponse(response, ok, error);
                            };
                            apiGeneral(url, method, data, success);
                        }).bind(this);
                        //lanzarConfirmacion(response.Objeto.PREGUNTA_HIST, acceptFn, cancelFn);
                        var btnFunctions = function () {
                            $("#btnPHSi").on("click", acceptFn);
                            $("#btnPHNo").on("click", cancelFn);
                        };
                        //var url = Router.action('Dialog', 'Dialog');
                        var url = "Dialog/Dialog";
                        var buttons = [
                            generateSingleButton("btnPHSi", "Aceptar", "pull-right"),
                            generateSingleButton("btnPHNo", "Cancelar", "pull-left", "gray")
                        ];
                        generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, response.Objeto.PREGUNTA_HIST);
                    } else {
                        var Ok = (function () {
                            closeModal('#dialogEnviosEtiquetas');
                            this./*exp*/Clear();
                        }).bind(this);
                        var error = function () {

                        };
                        if (response.Ok) {
                            lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, Ok);
                        } else {
                            lanzarMensaje(false, response.Mensaje, error);
                        }
                        //handleResponse(response, Ok, error);
                    }
                } else {
                    lanzarMensaje(response.Ok, response.Mensaje);
                }

            }).bind(this);

            //API call
            apiGeneral(url, method, data, success);
        }
        Expedicion.prototype.ImprimirFn = function () {
            var url = "expedicion/Expedir";
            var data = this./*exp*/v_orden_exp;
            var method = "POST";
            var success = (function (response) {
                var Ok = (function () {
                    //Params Impresión etiquetas
                    var url = "impresion/imprimiretiqueta";
                    var data = {
                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                        ggalbtip_cod: response.Objeto.GGALBTIP_COD,
                        n_albaran: response.Objeto.N_ALBARAN
                    };
                    var method = 'PUT';
                    var success = (function (response) {
                        if (response.Ok) {
                            var GGALBTIP_COD = response.Objeto.GGALBTIP_COD;
                            var N_ALBARAN = response.Objeto.N_ALBARAN;
                            if (response.Objeto.PREGUNTA_HIST) {
                                var acceptFn = (function () {
                                    var url = "/Expedicion/PonerHistorico";
                                    var method = "POST";
                                    var data = {
                                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                                        GGPEDTIP_COD: this./*exp*/v_orden_exp.GGPEDTIP_COD,
                                        N_PEDIDO: this./*exp*/v_orden_exp.N_PEDIDO
                                    };
                                    var success = (function (response) {
                                        var ok = (function () {
                                            closeModal('#dialogEnviosEtiquetas');
                                            closeModal("#dialogLoV");
                                            this./*exp*/Clear();
                                        }).bind(this);
                                        var error = function () {

                                        };
                                        if (response.Ok) {
                                            lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                                        } else {
                                            lanzarMensaje(false, response.Mensaje, error);
                                        }
                                        //handleResponse(response, ok, error);
                                    }).bind(this);
                                    apiGeneral(url, method, data, success);
                                }).bind(this);
                                var cancelFn = (function () {
                                    var url = "/Expedicion/DejarActivo";
                                    var method = "POST";
                                    var data = {
                                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                                        GGPEDTIP_COD: this./*exp*/v_orden_exp.GGPEDTIP_COD,
                                        N_PEDIDO: this./*exp*/v_orden_exp.N_PEDIDO
                                    };
                                    var success = (function (response) {
                                        var ok = (function () {
                                            closeModal("#dialogLoV");
                                            closeModal('#dialogEnviosEtiquetas');
                                            this./*exp*/Clear();
                                        }).bind(this);
                                        var error = function () {

                                        };

                                        if (response.Ok) {
                                            lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, ok);
                                        } else {
                                            lanzarMensaje(false, response.Mensaje, error);
                                        }
                                        //handleResponse(response, ok, error);
                                    }).bind(this);
                                    apiGeneral(url, method, data, success);
                                }).bind(this);
                                var btnFunctions = function () {
                                    $("#btnPHSi").on("click", acceptFn);
                                    $("#btnPHNo").on("click", cancelFn);
                                };
                                //var url = Router.action('Dialog', 'Dialog');
                                var url = "Dialog/Dialog";
                                var buttons = [
                                    generateSingleButton("btnPHSi", "Aceptar", "pull-right"),
                                    generateSingleButton("btnPHNo", "Cancelar", "pull-left", "gray")
                                ];
                                generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, response.Objeto.PREGUNTA_HIST);
                            } else {
                                var Ok = (function () {
                                    closeModal('#dialogEnviosEtiquetas');
                                    this./*exp*/Clear();
                                }).bind(this);
                                var error = function () {

                                };
                                if (response.Ok) {
                                    lanzarMensaje(true, "Se ha generado el albarán " + GGALBTIP_COD + " - " + N_ALBARAN, Ok);
                                } else {
                                    lanzarMensaje(false, response.Mensaje, error);
                                }
                                //handleResponse(response, Ok, error);
                            }
                        } else {
                            lanzarMensaje(response.Ok, response.Mensaje);
                        }
                    }).bind(this);
                    //API CALL Impresión de etiquetas
                    apiGeneral(url, method, data, success);
                }).bind(this);
                handleResponse(response, Ok);
            }).bind(this);

            apiGeneral(url, method, data, success);
        }
        Expedicion.prototype.GenerarExpedicion = function () {
            this./*exp*/DatosEnvio();
            this./*exp*/v_orden_exp['GGMENVIO_COD'] = $('#codTransporte').val();
            this./*exp*/v_orden_exp['GGVEHICULO_COD'] = $("#codVehiculo").val();
            this./*exp*/TransformExpedicion();
            this./*exp*/v_orden_exp.N_BULTOS = $('#bultosInput').val();
            this./*exp*/v_orden_exp.N_ETIQUETAS = $('#etiquetasInput').val();
            this./*exp*/v_orden_exp.PESO = $('#pesoInput').val();
            this./*exp*/v_orden_exp.ImprimirValorado = $(this./*exp*/chkAlbaranVal).is(':checked');
            this./*exp*/v_orden_exp.DejarPendiente = this./*exp*/DejarPendiente;
            this./*exp*/v_orden_exp.N_COPIAS = this./*exp*/DejarPendiente ? $('#CopiasInput').val() : null;

            this./*exp*/ExpedirFn();

        };

        Expedicion.prototype.TransformExpedicion = function () {
            if (eval(this./*exp*/v_orden_exp.N_BULTOS) > 0 && this./*exp*/v_orden_exp.Bultos.length > 0 && this./*exp*/v_orden_exp.Bultos[0].v_articulos) {
                this./*exp*/v_bultos = [];
                for (var i = 0; i < this./*exp*/v_orden_exp.Bultos.length; i++) {
                    for (j = 0; j < this./*exp*/v_orden_exp.Bultos[i].v_articulos.length; j++) {
                        this./*exp*/v_orden_exp.Bultos[i].v_articulos[j].GVPALLETIP_COD = this./*exp*/v_orden_exp.Bultos[i].v_tipoBulto;
                        this./*exp*/v_bultos.push(this./*exp*/v_orden_exp.Bultos[i].v_articulos[j]);
                    }
                }
                this./*exp*/v_orden_exp.Bultos = this./*exp*/v_bultos;
            }
        };

        return Expedicion;
    });