﻿/// <reference path="jquery-1.12.4.js" />
/// <autosync enabled="true" />
/// <reference path="../areas/ojarem/scripts/subcontrataciones.js" />
/// <reference path="../areas/tmi/scripts/acopioofcus.js" />
/// <reference path="../areas/tmi/scripts/inventarioubicacioncus.js" />
/// <reference path="../areas/tmi/scripts/movimientoscus.js" />
/// <reference path="../areas/tmi/scripts/traspasosarticulos.js" />
/// <reference path="../areas/tmi/scripts/traspasoscus.js" />
/// <reference path="_moment/locale/af.js" />
/// <reference path="_moment/locale/ar.js" />
/// <reference path="_moment/locale/ar-dz.js" />
/// <reference path="_moment/locale/ar-kw.js" />
/// <reference path="_moment/locale/ar-ly.js" />
/// <reference path="_moment/locale/ar-ma.js" />
/// <reference path="_moment/locale/ar-sa.js" />
/// <reference path="_moment/locale/ar-tn.js" />
/// <reference path="_moment/locale/az.js" />
/// <reference path="_moment/locale/be.js" />
/// <reference path="_moment/locale/bg.js" />
/// <reference path="_moment/locale/bm.js" />
/// <reference path="_moment/locale/bn.js" />
/// <reference path="_moment/locale/bo.js" />
/// <reference path="_moment/locale/br.js" />
/// <reference path="_moment/locale/bs.js" />
/// <reference path="_moment/locale/ca.js" />
/// <reference path="_moment/locale/cs.js" />
/// <reference path="_moment/locale/cv.js" />
/// <reference path="_moment/locale/cy.js" />
/// <reference path="_moment/locale/da.js" />
/// <reference path="_moment/locale/de.js" />
/// <reference path="_moment/locale/de-at.js" />
/// <reference path="_moment/locale/de-ch.js" />
/// <reference path="_moment/locale/dv.js" />
/// <reference path="_moment/locale/el.js" />
/// <reference path="_moment/locale/en-au.js" />
/// <reference path="_moment/locale/en-ca.js" />
/// <reference path="_moment/locale/en-gb.js" />
/// <reference path="_moment/locale/en-ie.js" />
/// <reference path="_moment/locale/en-nz.js" />
/// <reference path="_moment/locale/eo.js" />
/// <reference path="_moment/locale/es.js" />
/// <reference path="_moment/locale/es-do.js" />
/// <reference path="_moment/locale/es-us.js" />
/// <reference path="_moment/locale/et.js" />
/// <reference path="_moment/locale/eu.js" />
/// <reference path="_moment/locale/fa.js" />
/// <reference path="_moment/locale/fi.js" />
/// <reference path="_moment/locale/fo.js" />
/// <reference path="_moment/locale/fr.js" />
/// <reference path="_moment/locale/fr-ca.js" />
/// <reference path="_moment/locale/fr-ch.js" />
/// <reference path="_moment/locale/fy.js" />
/// <reference path="_moment/locale/gd.js" />
/// <reference path="_moment/locale/gl.js" />
/// <reference path="_moment/locale/gom-latn.js" />
/// <reference path="_moment/locale/gu.js" />
/// <reference path="_moment/locale/he.js" />
/// <reference path="_moment/locale/hi.js" />
/// <reference path="_moment/locale/hr.js" />
/// <reference path="_moment/locale/hu.js" />
/// <reference path="_moment/locale/hy-am.js" />
/// <reference path="_moment/locale/id.js" />
/// <reference path="_moment/locale/is.js" />
/// <reference path="_moment/locale/it.js" />
/// <reference path="_moment/locale/ja.js" />
/// <reference path="_moment/locale/jv.js" />
/// <reference path="_moment/locale/ka.js" />
/// <reference path="_moment/locale/kk.js" />
/// <reference path="_moment/locale/km.js" />
/// <reference path="_moment/locale/kn.js" />
/// <reference path="_moment/locale/ko.js" />
/// <reference path="_moment/locale/ky.js" />
/// <reference path="_moment/locale/lb.js" />
/// <reference path="_moment/locale/lo.js" />
/// <reference path="_moment/locale/lt.js" />
/// <reference path="_moment/locale/lv.js" />
/// <reference path="_moment/locale/me.js" />
/// <reference path="_moment/locale/mi.js" />
/// <reference path="_moment/locale/mk.js" />
/// <reference path="_moment/locale/ml.js" />
/// <reference path="_moment/locale/mr.js" />
/// <reference path="_moment/locale/ms.js" />
/// <reference path="_moment/locale/ms-my.js" />
/// <reference path="_moment/locale/mt.js" />
/// <reference path="_moment/locale/my.js" />
/// <reference path="_moment/locale/nb.js" />
/// <reference path="_moment/locale/ne.js" />
/// <reference path="_moment/locale/nl.js" />
/// <reference path="_moment/locale/nl-be.js" />
/// <reference path="_moment/locale/nn.js" />
/// <reference path="_moment/locale/pa-in.js" />
/// <reference path="_moment/locale/pl.js" />
/// <reference path="_moment/locale/pt.js" />
/// <reference path="_moment/locale/pt-br.js" />
/// <reference path="_moment/locale/ro.js" />
/// <reference path="_moment/locale/ru.js" />
/// <reference path="_moment/locale/sd.js" />
/// <reference path="_moment/locale/se.js" />
/// <reference path="_moment/locale/si.js" />
/// <reference path="_moment/locale/sk.js" />
/// <reference path="_moment/locale/sl.js" />
/// <reference path="_moment/locale/sq.js" />
/// <reference path="_moment/locale/sr.js" />
/// <reference path="_moment/locale/sr-cyrl.js" />
/// <reference path="_moment/locale/ss.js" />
/// <reference path="_moment/locale/sv.js" />
/// <reference path="_moment/locale/sw.js" />
/// <reference path="_moment/locale/ta.js" />
/// <reference path="_moment/locale/te.js" />
/// <reference path="_moment/locale/tet.js" />
/// <reference path="_moment/locale/th.js" />
/// <reference path="_moment/locale/tlh.js" />
/// <reference path="_moment/locale/tl-ph.js" />
/// <reference path="_moment/locale/tr.js" />
/// <reference path="_moment/locale/tzl.js" />
/// <reference path="_moment/locale/tzm.js" />
/// <reference path="_moment/locale/tzm-latn.js" />
/// <reference path="_moment/locale/uk.js" />
/// <reference path="_moment/locale/ur.js" />
/// <reference path="_moment/locale/uz.js" />
/// <reference path="_moment/locale/uz-latn.js" />
/// <reference path="_moment/locale/vi.js" />
/// <reference path="_moment/locale/x-pseudo.js" />
/// <reference path="_moment/locale/yo.js" />
/// <reference path="_moment/locale/zh-cn.js" />
/// <reference path="_moment/locale/zh-hk.js" />
/// <reference path="_moment/locale/zh-tw.js" />
/// <reference path="_moment/moment.js" />
/// <reference path="_moment/moment-with-locales.js" />
/// <reference path="ai.0.22.9-build00167.min.js" />
/// <reference path="bootstrap.min.js" />
/// <reference path="bootstrap/bootstrap.js" />
/// <reference path="bootstrap/datepicker/js/bootstrap-datepicker.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ar.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.az.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.bg.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.bs.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ca.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.cs.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.cy.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.da.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.de.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.el.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.en-AU.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.en-GB.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.eo.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.es.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.et.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.eu.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.fa.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.fi.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.fo.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.fr.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.fr-CH.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.gl.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.he.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.hr.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.hu.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.hy.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.id.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.is.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.it.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.it-CH.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ja.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ka.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.kh.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.kk.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ko.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.kr.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.lt.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.lv.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.me.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.mk.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.mn.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ms.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.nb.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.nl.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.nl-BE.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.no.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.pl.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.pt.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.pt-BR.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ro.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.rs.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.rs-latin.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.ru.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sk.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sl.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sq.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sr.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sr-latin.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sv.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.sw.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.th.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.tr.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.uk.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.vi.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.zh-CN.min.js" />
/// <reference path="bootstrap/datepicker/locales/bootstrap-datepicker.zh-TW.min.js" />
/// <reference path="camera/cameracall.js" />
/// <reference path="camera/quagga.min.js" />
/// <reference path="datatables/autofill.bootstrap.min.js" />
/// <reference path="datatables/autofill.bootstrap4.min.js" />
/// <reference path="datatables/autofill.foundation.min.js" />
/// <reference path="datatables/autofill.jqueryui.min.js" />
/// <reference path="datatables/autofill.semanticui.min.js" />
/// <reference path="datatables/buttons.bootstrap.min.js" />
/// <reference path="datatables/buttons.bootstrap4.min.js" />
/// <reference path="datatables/buttons.colvis.min.js" />
/// <reference path="datatables/buttons.flash.min.js" />
/// <reference path="datatables/buttons.foundation.min.js" />
/// <reference path="datatables/buttons.html5.min.js" />
/// <reference path="datatables/buttons.jqueryui.min.js" />
/// <reference path="datatables/buttons.print.min.js" />
/// <reference path="datatables/buttons.semanticui.min.js" />
/// <reference path="datatables/datatables.autofill.min.js" />
/// <reference path="datatables/datatables.bootstrap.min.js" />
/// <reference path="datatables/datatables.bootstrap4.min.js" />
/// <reference path="datatables/datatables.buttons.min.js" />
/// <reference path="datatables/datatables.colreorder.min.js" />
/// <reference path="datatables/datatables.fixedcolumns.min.js" />
/// <reference path="datatables/datatables.fixedheader.min.js" />
/// <reference path="datatables/datatables.foundation.min.js" />
/// <reference path="datatables/datatables.jqueryui.min.js" />
/// <reference path="datatables/datatables.keytable.min.js" />
/// <reference path="datatables/datatables.material.min.js" />
/// <reference path="datatables/datatables.responsive.min.js" />
/// <reference path="datatables/datatables.rowgroup.min.js" />
/// <reference path="datatables/datatables.rowreorder.min.js" />
/// <reference path="datatables/datatables.scroller.min.js" />
/// <reference path="datatables/datatables.select.min.js" />
/// <reference path="datatables/datatables.semanticui.min.js" />
/// <reference path="datatables/datatables.uikit.min.js" />
/// <reference path="datatables/jquery.datatables.min.js" />
/// <reference path="datatables/responsive.bootstrap.min.js" />
/// <reference path="datatables/responsive.bootstrap4.min.js" />
/// <reference path="datatables/responsive.foundation.min.js" />
/// <reference path="datatables/responsive.jqueryui.min.js" />
/// <reference path="datatables/responsive.semanticui.min.js" />
/// <reference path="datepicker.js" />
/// <reference path="jquery-1.10.2.min.js" />
/// <reference path="jquery-1.12.4.min.js" />
/// <reference path="jquery-ui-1.12.1.js" />
/// <reference path="jquery-ui-1.12.1.min.js" />
/// <reference path="js/jquery.datatables.min.js" />
/// <reference path="js/jquery-ui.min.js" />
/// <reference path="js/pagejumptodata.js" />
/// <reference path="login/login.js" />
/// <reference path="modernizr-2.6.2.js" />
/// <reference path="movimientos/inventario.js" />
/// <reference path="movimientos/inventario2.js" />
/// <reference path="pedidos/pedidos_bultos.js" />
/// <reference path="pedidos/pedidos_envios.js" />
/// <reference path="pedidos/pedidos_expedicion.js" />
/// <reference path="pedidos/pedidos_menupedidos.js" />
/// <reference path="pedidos/pedidos_pedidos.js" />
/// <reference path="pedidos/pedidos_ubicaciones.js" />
/// <reference path="pedidoscliente/pedidos_cliente.js" />
/// <reference path="pedidoscliente/pedidos_cliente_bultos.js" />
/// <reference path="pedidoscliente/pedidos_cliente_envios.js" />
/// <reference path="pedidoscliente/pedidos_cliente_expedicion.js" />
/// <reference path="pedidoscliente/pedidos_cliente_menu.js" />
/// <reference path="pedidoscliente/pedidos_cliente_ubicaciones.js" />
/// <reference path="r.js" />
/// <reference path="recepcion/recepcion_menupedidos.js" />
/// <reference path="recepcion/recepcion_pedidos.js" />
/// <reference path="recepcion/recepcion_ubicaciones.js" />
/// <reference path="require.js" />
/// <reference path="respond.js" />
/// <reference path="scripts/dateutil.js" />
/// <reference path="scripts/decodificador.js" />
/// <reference path="scripts/empresas.js" />
/// <reference path="scripts/funciones.js" />
/// <reference path="scripts/funciones_albaranes.js" />
/// <reference path="scripts/pagauto.js" />
/// <reference path="scripts/resizes.js" />
/// <reference path="utilidades/consultas.js" />
/// <reference path="utilidades/impresion-pedido.js" />
