var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Pantalla = void 0;
    class Pantalla {
        constructor() {
            this._primeraVez = true;
        }
        alSalir(callback) {
            if (Pantalla.manejadores[this.constructor.name])
                window.removeEventListener('popstate', Pantalla.manejadores[this.constructor.name]);
            if (callback === null)
                return;
            if (this._primeraVez) {
                window.history.pushState(null, null, window.location.pathname);
                this._primeraVez = false;
            }
            const v_manejador = {
                handleEvent: function (event) {
                    return __awaiter(this, void 0, void 0, function* () {
                        yield callback();
                        window.removeEventListener('popstate', v_manejador);
                        delete Pantalla.manejadores[this.constructor.name];
                        window.history.back();
                    });
                }
            };
            window.addEventListener('popstate', v_manejador, false);
            Pantalla.manejadores[this.constructor.name] = v_manejador;
        }
    }
    Pantalla.manejadores = {};
    exports.Pantalla = Pantalla;
});
