import { ComponenteHTML } from 'componentes/componente-html';
export declare class DefinicionLabel extends ComponenteHTML {
    private _valores;
    constructor(_elemento: HTMLElement, _valores: {
        texto?: string;
        valor?: string;
    });
    texto(p_valor: string): DefinicionLabel;
    valor(p_valor: string): DefinicionLabel;
    crea(): Label;
}
export declare class Label extends ComponenteHTML {
    private _valores;
    constructor(_elemento: HTMLElement, _valores: {
        texto?: string;
        valor?: string;
    });
    texto(p_valor: string): string;
    valor(p_valor: string): string;
    visible(p_valor: boolean): boolean;
}
export declare function label(p_elemento: HTMLElement | string): DefinicionLabel;
