﻿$(document).ready(function () {
    var txtArt = document.getElementById('txtArtRef');
    var txtArtDescrip = document.getElementById('txtArtDescrip');
    var txtUbic = document.getElementById('txtUbic');
    var txtUbicTemp = document.getElementById('txtUbicTemp');
    var txtDate = document.getElementById('date');
    var txtCopias = document.getElementById('txtCopias');
    var inputPlaceHolder = document.getElementById('inputPlaceHolder');
    var txtPrograma = document.getElementById('txtPrograma');
    var tipo = $('#tipo');
    var btnConfirmar = document.getElementById('btnConfirmar');

    var campos = [];

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtArt).keypress(function (e) { if (e.which === 13) validarArticulo(); });
    $(txtArt).on("change", function (e) { validarArticulo(); });
    addEvent(btnConfirmar, 'click', confirmarEtiquetas, false);

    inicioEtiquetas();
    opcionesImpresion();

    function inicioEtiquetas() {

        var url = "Etiquetas/Inicio";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            PROGRAMA: $(txtPrograma).val()
        };
        var success = function (response) {
            var Ok = function () {
                $(txtCopias).val(response.Objeto.COPIAS);

                var inputTypeMap = {
                    CHAR: 'text',
                    NUM: 'number',
                    FEC: 'date'
                };

                $.each(response.Objeto.Campos, function (i, campo) {
                    var label = document.createElement('label');
                    var innerDiv = document.createElement('div');
                    var newCampo = document.createElement('input');
                    var fieldset = document.createElement('div');

                    $(label).text(campo.PROMPT);
                    $(label).addClass('col-xs-4');

                    var inputType = inputTypeMap[campo.TIPO];
                    if (inputType === 'date') {
                        dateArray = campo.VALOR.split('/');
                        date = new Date(dateArray[1] + '/' + dateArray[0] + '/' + dateArray[2]);
                        //var date = new Date(campo.VALOR)
                        $(newCampo).datepicker({
                            format: Globalize($("html").attr("lang")).culture().calendar.patterns.d.toLowerCase(),
                            language: Globalize($("html").attr("lang")).cultureSelector.split('-')[0],
                            autoclose: true,
                            orientation: "auto",
                            useLocalTimezone: false,
                            widgetPositioning: {
                                horizontal: 'right',
                                vertical: 'bottom'
                            }
                        }).datepicker("setDate", date).addClass('text-center');
                    } else {
                        var textCls = inputType[campo.TIPO] === 'number' ? 'text-right' : '';
                        $(newCampo).val(campo.VALOR);
                        $(newCampo).prop('type', inputType);
                    }
                    $(newCampo).addClass('form-control input-sm input-xs focusable ' + textCls);
                    $(newCampo).prop('id', campo.PARAMETRO);
                    $(newCampo).prop('PARAMETRO', campo.PARAMETRO);

                    $(newCampo).PARAMETRO
                    campos.push(newCampo);

                    $(innerDiv).addClass('col-xs-8');
                    $(innerDiv).append(newCampo);

                    $(fieldset).addClass('fieldset');
                    $(fieldset).append(label);
                    $(fieldset).append(innerDiv);

                    $(inputPlaceHolder).append($(fieldset));
                    tabulado();
                });


            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }


    function opcionesImpresion() {
        var url = "Etiquetas/OpcionesImpresion";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            PROGRAMA: $(txtPrograma).val()
        };
        var success = function (response) {
            var Ok = function () {
                $.each(response.Objeto, function (i, Obj) {
                    tipo.append($('<option>', {
                        value: Obj.OPCION,
                        text: Obj.OPCION,
                        DOCTIP: Obj.DOCTIP
                    }));
                });
            };
               
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }

    function confirmarEtiquetas() {
        var params = {};
        campos.forEach(function (camp) {
            params[camp.PARAMETRO] = $(camp).val();
        });

        var v_url = "Etiquetas/Imprimir";
        var v_method = "PUT";
        var v_data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            PROGRAMA: $(txtPrograma).val(),
            GAART_COD: $(txtArt).val(),
            COPIAS: $(txtCopias).val(),
            Parametros: params,
            DOCTIP: tipo.find(':selected').attr('doctip'),
            OPCION: tipo.val()
        };
        
        var v_success = function (p_response) {
            if (p_response.Ok) {
                successMessage(p_response.Mensaje);
            } else {
                handleResponse(p_response);
            }
        };
        apiGeneral(v_url, v_method, v_data, v_success);
    }

    function validarArticulo() {
        var url = "Etiquetas/Articulo";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            GAART_COD: $(txtArt).val()
        };
        var success = function (response) {
            var Ok = function () {
                $(txtArt).val(response.Objeto.COD);
                $(txtArtDescrip).val(response.Objeto.DESCRIP);
            };
            var error = function () {
                $(txtArt).focus().select();
            };

            handleResponse(response, Ok, error);
        };
        apiGeneral(url, method, data, success);
    }
});