﻿$(document).ready(function () {

    //Elementos
    var txtAlbaran = document.getElementById('txtAlbaran');
    var txtMatricula = document.getElementById('txtMatricula');
    var txtNomCli = document.getElementById('txtNomCli');
    var txtDireccion = document.getElementById('txtDireccion');
    var txtFecha = document.getElementById('txtFecha');
    var txtInt = document.getElementById('txtInt');
    var txtPais = document.getElementById('txtPais');
    var txtTelefono = document.getElementById('txtTelefono');
    var txtBultos = document.getElementById('txtBultos');
    var txtPeso = document.getElementById('txtPeso');
    var txtTransporte = document.getElementById('txtTransporte');
    var txtOperario = document.getElementById('txtOperario');
    var txtOperarioDescrip = document.getElementById('txtOperarioDescrip');
    var btnOperarios = document.getElementById('btnOperarios');
    var btnFirma = document.getElementById('btnFirma');
    var btnConfirm = document.getElementById('btnConfirm');
    var btnLimpiar = document.getElementById('btnLimpiar');
    var datos = {};
    var operarioOblig;
    function isFilled() {
        var filled =
            $(txtMatricula).val().trim() === "" ||
                $(txtTelefono).val().trim() === "" ||
                $(txtAlbaran).val().trim() === "" ||
                $(txtFecha).val().trim() === "" ||
                $(txtPais).val().trim() === "" ||
                $(txtInt).val().trim() === ""
                ? false : true;
        if (operarioOblig)
            filled = $(txtOperarioDescrip).val().trim() !== "" &&
                $(txtOperario).val().trim() !== "" && filled ? true : false;
        return filled;
    }
    //Eventos
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtAlbaran).keypress(function (e) { if (e.which === 13 && $(txtAlbaran).val() !== "") dameDatos(); });
    $(txtAlbaran).on("change", function (e) { if ($(txtAlbaran).val() !== "") dameDatos(); });
    //$(txtOperario).on('blur', function () { if ($(txtOperario).val() !== "") verificaOperario(); });
    $(txtOperario).on('change', function () { if ($(txtOperario).val() !== "") verificaOperario(); });
    $(txtPais).on('keyup', function (e) {
        paisTlf(e, txtPais, txtTelefono);
    });
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtPais).keydown(function (e) { if (e.which === 13) { completeFieldNumber(txtPais); } });
    $(txtPais).on("change", function (e) { completeFieldNumber(txtPais); });
    $(txtInt).on('keyup', function (e) {
        paisTlf(e, txtInt, txtPais);
        if (e.which === 13) {
            $(txtPais).focus().select();
        }
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtTelefono).keyup(function (e) { if (e.which === 13 && $(txtTelefono).val() === "") { $(this).focus(); } });
    //$(txtInt).keypress(function (e) { if (e.which === 13) { completeFieldNumber(txtInt); } });
    $(txtTelefono).on("change", function (e) { if ($(txtTelefono).val() === "") { $(this).focus(); } });
    $(txtInt).on("change", function (e) { completeFieldNumber(txtInt); });

    addEvent(btnOperarios, 'click', dameOperarios, false);
    addEvent(btnFirma, 'click', dameFirma, false);
    addEvent(btnLimpiar, 'click', limpiarCampos, false);

    operarioObligarorio();
    $(txtFecha).datepicker({
        format: Globalize($("html").attr("lang")).culture().calendar.patterns.d.toLowerCase(),
        language: Globalize($("html").attr("lang")).cultureSelector.split('-')[0],
        autoclose: true,
        useLocalTimezone: false,
        orientation: "auto",
        widgetPositioning: {
            horizontal: 'right',
            vertical: 'bottom'
        }
    }).datepicker("setDate", 'now');

    function completeFieldNumber(field) {
        while ($(field).val().length < 2) {
            $(field).val('0' + $(field).val());
        }
    }

    function paisTlf(event, field, targetField) {
        const isNumber = isFinite(event.key);
        if ($(field).val().trim().length === 3)
            if (isNumber) {
                $(targetField).focus().select();
            } else {
                $(field).focus().select();
            }
    }

    $(txtFecha).datepicker()
        .on('hide', function (e) {
            dateShowing = false;
        });

    // Funciones
    function operarioObligarorio() {
        var url = "RF_Exwork/Inicio";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            var Ok = function () {
                (operarioOblig = response.Objeto.OPER_OBL) ? $(operarioBox).show() : $(operarioBox).hide();
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }

    function limpiarCampos() {
        $(txtAlbaran).val("");
        $(txtMatricula).val("");
        $(txtNomCli).val("");
        $(txtDireccion).val("");
        $(txtFecha).datepicker("setDate", 'now');
        $(txtInt).val("00");
        $(txtPais).val("");
        $(txtTelefono).val("");
        $(txtBultos).val("");
        $(txtPeso).val("");
        $(txtTransporte).val("");
        $(txtOperario).val("");
        $(txtOperarioDescrip).val("");
        $(txtAlbaran).focus();
        datos = {};
    }
    function dameDatos() {
        var albaran = $(txtAlbaran).val();

        var url = "RF_Exwork/Get";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            albaran: albaran
        };
        var success = function (response) {
            var Ok = function () {
                var obj = response.Objeto;

                datos.NOMCLI = obj.NOMCLI;
                datos.DIR = obj.DIR;
                datos.TIP_VC = obj.TIP_VC;
                datos.GGALBTIP_COD = obj.GGALBTIP_COD;
                datos.N_ALBARAN = obj.N_ALBARAN;
                datos.BULTOS = obj.BULTOS;
                datos.PESO = obj.PESO;
                datos.GGMENVIO_DES = obj.GGMENVIO_DES;

                $(txtNomCli).val(datos.NOMCLI);
                $(txtDireccion).val(datos.DIR);
                $(txtTransporte).val(datos.GGMENVIO_DES);
                $(txtBultos).val(datos.BULTOS);
                $(txtPeso).val(datos.PESO);
            };
            var error = function () { $(txtAlbaran).focus(); };

            handleResponse(response, Ok, error);
        };
        apiGeneral(url, method, data, success);
    }

    function dameOperarios() {
        var url = "RF_Exwork/Operarios";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            var Ok = function () {
                //var url = Router.action('Dialog', 'Dialog');
                var url = 'Dialog/Dialog';
                var columns = [generateColumn('COD', Resources.table_head_code), generateColumn('NOMBRE', Resources.table_head_name)];
                var buttons = [generateSingleButton('aceptar', Resources.button_accept), generateSingleButton('cerrar', Resources.button_cancel, 'pull-left')];
                var columnDefs = [
                    { "width": "8em", "targets": 0 }
                    //{ "width": "45%", "targets": 1 },
                ];

                generarDialogAuto(url, "#dialogLoV", "tablaOperarios", null, response.Objeto, columns, buttons, null, null, recogeOperarios, "Lista de Operarios", null, null, null, null, null, null, columnDefs, true);
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }
    function recogeOperarios() {
        var btnAccept = document.getElementById('aceptar');
        addEvent(btnAccept, 'click', recogeOperario);

        var btnCancel = document.getElementById('cancelar');
        $(btnCancel).on('click', function () { closeModal('#dialogLoV'); });

        var table = $('#tablaOperarios').DataTable();

        function recogeOperario() {
            if (table.rows().data().length !== 0) {
                datos.GPOPER_COD = table.rows('.selected').data()[0].COD;
                datos.GPOPER_NOMBRE = table.rows('.selected').data()[0].NOMBRE;

                $(txtOperario).val(datos.GPOPER_COD);
                $(txtOperarioDescrip).val(datos.GPOPER_NOMBRE);
            }
            closeModal('#dialogLoV');
        }
    }

    function verificaOperario() {
        var url = "RF_Exwork/Operario";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            gpoper_cod: $(txtOperario).val()
        };
        var success = function (response) {
            var Ok = function () {
                datos.GPOPER_COD = $(txtOperario).val();
                datos.GPOPER_NOMBRE = response.Objeto.NOMBRE;

                $(txtOperarioDescrip).val(datos.GPOPER_NOMBRE);
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }

    function dameFirma() {
        if (isFilled()) {
            //var url = Router.action('Signature', 'Signature');
            var url = '/Signature/Signature';

            var buttons = [
                generateSingleButton('accept', 'Aceptar', 'pull-right'),
                generateSingleButton('cancel', 'Cancelar', 'pull-left'),
                generateSingleButton('clear', 'Limpiar', 'mid')
            ];


            generarDialogAuto(url, '#dialogLoV', "Firma", null, null, null, buttons, null, null, getSignature, "Firma");
        } else {
            lanzarMensaje(true, "Debe rellenar los campos antes de realizar la firma.");
        }
    }

    function getSignature() {
        $('#signature-pad .botoneraLateral').removeClass('botoneraLateral');
        $('#accept').on('click', function () {
            datos.FIRMA = getBase64();
            if (!$.isEmptyObject(datos) && datos.FIRMA) {
                var d = $(txtFecha).datepicker("getDate");
                var p_peticion = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    "TIP_VC": datos.TIP_VC,
                    "GGALBTIP_COD": datos.GGALBTIP_COD,
                    "N_ALBARAN": datos.N_ALBARAN,
                    "GPOPER_COD": datos.GPOPER_COD,
                    "CLINOM": datos.NOMCLI,
                    "DIRCOMPLETA": datos.DIR,
                    "GGMENVIO_DES": datos.GGMENVIO_DES,
                    "FECHA_EXW": new Date(d.getTime() - d.getTimezoneOffset() * 60000).toJSON(),
                    "MATRICULA": $(txtMatricula).val(),
                    "Telefono": {
                        "INT": $(txtInt).val(),
                        "PAIS": $(txtPais).val(),
                        "NUMERO": $(txtTelefono).val()
                    },
                    "Firma": datos.FIRMA
                };
                var url = "RF_Exwork/Finaliza";
                var method = "PUT";
                var data = p_peticion;
                var success = function (response) {
                    var Ok = function () {
                        if (!response.Mensaje) {

                            // TODO: Traducir
                            successMessage("Proceso exitoso");
                        }
                        limpiarCampos();
                    };
                    handleResponse(response, Ok);
                };
                apiGeneral(url, method, data, success);
            } else {
                if ($.isEmptyObject(datos))
                    lanzarMensaje(false, "Rellene los datos");
                else if (!datos.FIRMA)
                    lanzarMensaje(false, "Debe realizar una firma.");
            }
            closeModal('#dialogLoV');
        });
        $('#clear').on('click', function () {
            clearCanvas();
        });
        $('#cancel').on('click', function () {
            clearCanvas();
            closeModal('#dialogLoV');
        });
    }
});