﻿$(document).ready(function () {
    var table = $('#KitMontaje');
    generateTable();
    //drawTable();
    var dataTable = table.DataTable();
    var $table = table.dataTable();

    var txtArtCod = document.getElementById('txtArticuloCod');
    var txtArtDescrip = document.getElementById('txtArticuloDescrip');
    var txtExistenciasAgrupadas = document.getElementById('txtExistenciasAgrupadas');
    var txtExistenciasAlmacen = document.getElementById('txtExistenciasAlmacen');
    var txtUnidad = document.getElementById('txtUnidad');
    var txtCant = document.getElementById('txtCant');
    var txtLoteDest = document.getElementById('txtLoteDest');
    var txtUbicacionDest = document.getElementById('txtUbicacionDest')

    var btnGenerar = document.getElementById('btnGenerar');
    var btnLote = document.getElementById('btnLote');
    var btnUbicacion = document.getElementById('btnUbicacion');

    var CONFIG = {};

    var Articulo_aux = {};
    var Articulo = {
        "EMPGRUPO_COD": "",
        "EMP_COD": "",
        "GAART_COD": "",
        "C_UNID1": 0,
        "C_UNID2": 0,
        "LOTES_SN": "",
        "UBIC_SN": "",
        "LOTE": "",
        Lotes: [],
        "GAUBIC_COD": "",
        "Componentes": [
        ]
    }



    inicio();
    modCellValue();
    //drawRows();

    //Eventos
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtArtCod).keypress(function (e) { if (e.which == 13) buscaArticulo(); });
    //$(txtCant).keypress(function (e) { if (e.which == 13) obtenerComponentes() });
    $(txtArtCod).on("change", function (e) { buscaArticulo(); });
    $(txtCant).on("change", function (e) { obtenerComponentes() });

    addEvent(btnLote, 'click', obtenLotes, false);
    addEvent(btnUbicacion, 'click', obtenUbicaciones, false);
    addEvent(btnGenerar, 'click', function () { clearBatches(); montarKit() }, false);

    function clear() {
        var Articulo_aux = {};
        var Articulo = {
            "EMPGRUPO_COD": "",
            "EMP_COD": "",
            "GAART_COD": "",
            "C_UNID1": 0,
            "C_UNID2": 0,
            "LOTES_SN": "",
            "UBIC_SN": "",
            "LOTE": "",
            Lotes: [],
            "GAUBIC_COD": "",
            "Componentes": [
            ]
        }

        $(txtArtCod).val("");
        $(txtArtDescrip).val("");
        $(txtExistenciasAgrupadas).val("");
        $(txtExistenciasAlmacen).val("");
        $(txtUnidad).val("");
        $(txtCant).val("");
        $(txtLoteDest).val(CONFIG.LOTE_ENTRADA_DEF);
        $(txtUbicacionDest).val(CONFIG.UBIC_ENTRADA_DEF);

        dataTable.clear().draw();
    }

    function clearBatches() {
        Articulo.Lotes = [];
        Articulo.Componentes.forEach(function (C) {
            if (C)
                C.Lotes = [];
        });
    }
    function inicio() {
        var url = "RF_Kits/Inicio";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        }
        var success = function (response) {
            if (response.Ok) {
                var obj = response.Objeto;
                CONFIG.PERMITE_MODIF_CANT_COMP = true; //obj.PERMITE_MODIF_CANT_COMP;
                CONFIG.VER_LOTEUBIC_UNICO_E = obj.VER_LOTEUBIC_UNICO_E;
                CONFIG.LOTE_ENTRADA_DEF = obj.LOTE_ENTRADA_DEF;
                CONFIG.UBIC_ENTRADA_DEF = obj.UBIC_ENTRADA_DEF;

                $(txtLoteDest).val(obj.LOTE_ENTRADA_DEF);
                $(txtUbicacionDest).val(obj.UBIC_ENTRADA_DEF);
                if (!CONFIG.VER_LOTEUBIC_UNICO_E) {
                    $('.destino').css('display', 'none');
                } else {
                    $('.destino').css('display', 'block');
                }
            }
        };
        apiGeneral(url, method, data, success);
    }

    function montarKit() {
        var components = dataTable.rows().data().toArray();

        var url = "RF_Kits/MontarKit";
        var method = "PUT";
        Articulo.EMPGRUPO_COD = sessionStorage.getItem("EMPRGRUP_COD");
        Articulo.EMP_COD = sessionStorage.getItem("EMPR_COD");

        if (Articulo.Componentes.length == 0) {
            Articulo.Componentes = JSON.parse(JSON.stringify(components));
        }
        for (var i = 0; i < components.length; i++) {
            if (Articulo.Componentes[i])
                Articulo.Componentes[i].C_UNID1 = components[i] ? components[i].C_UNID1 : 0;
        }

        var data = Articulo;

        if (Articulo.Lotes.length == 0) {
            var ubicDef = {
                LOTE: $(txtLoteDest).val(),
                GAUBIC_COD: $(txtUbicacionDest).val(),
                C_UNID1: $(txtCant).val()
            }
            Articulo.Lotes.push(ubicDef);
        }

        data.Componentes.forEach(function (data) {
            if (data)
                data.PR_PRECIO = data.PRECIO;
        });
        var success = function (response) {
            if (response.Ok) {
                if (response.Mensaje && response.Objeto == null) {
                    lanzarMensaje(true, response.Mensaje);
                } else if (response.Objeto) {
                    fnComponents();
                } else {
                    clear();
                    successMessage("Montaje generado correctamente");
                }
                function fnComponents() {
                    if (response.Objeto != null) {
                        Articulo_aux = JSON.parse(JSON.stringify(Articulo));
                        if (response.Objeto.Tipo == "LOTES")
                            getComponents(response.Objeto.Avisos);
                    } else {
                    }
                }
            }
            else {
                lanzarMensaje(false, response.Mensaje);
            }
        }
        apiGeneral(url, method, data, success);
    }

    function generateArticle() {
        Articulo.GAART_COD = $(txtArtCod).val();
        getComponents(0);
    }

    function getComponents(components) {
        if (components.length != 0) {
            var v_data;
            var v_row = 0;
            var component = components.shift();
            var compMessage = component.MENSAJE;
            var isParentComponent = component.GAART_COD == Articulo.GAART_COD;

            if (isParentComponent) {
                Articulo.Lotes = [];
                v_data = component;
                v_data.C_UNID1 = Articulo.C_UNID1;
                v_data.GAART_DESCRIP = Articulo.GAART_DESCRIP;
            } else {
                dataTable.rows(function (idx, data, node) {
                    if (data['GAART_COD'] == component.GAART_COD) {
                        v_data = data;
                        v_row = idx;
                    }

                });
                v_data.Lotes = component.Lotes;
            }
            Articulo.Componentes[v_row].Lotes = [];
            //var v_url = Router.action("Dialog", "Dialog");
            var v_url = "Dialog/Dialog";
            var dialogId = '#dialogLoV';
            var tableName = 'tablaUbic';
            var v_columns = [
                generateColumn("GAUBIC_COD", 'Ubicacion'),
                generateColumn("LOTE", Resources.table_head_batch),
                generateColumn("C_UNID1", Resources.table_head_quantity, true, true)
            ]
            if (isParentComponent) {
                var v_buttons = [
                    generateSingleButton('btnAccept', Resources.button_accept, "pull-right")
                ];
            } else {
                var v_buttons = [
                    generateSingleButton('btnReset', "Reiniciar", 'pull-left'),
                    generateSingleButton('btnAccept', Resources.button_accept, "pull-right")
                ];
            }
            var v_inputs = [
                generateSingleInput(12, "Ubic.", 'diagTxtUbic', "", "", "focusable"),
                generateSingleInput(12, "Lote", 'diagTxtLote', "", "", "focusable"),
                generateSingleInput(12, "Cant", 'diagTxtCant', "", "", "focusable text-right")
            ]
            var v_upperInputs = [
                generateSingleInput(6, 'Artículo', 'diagTxtDescrip', v_data.GAART_DESCRIP),
                generateSingleInput(6, 'Cantidad', 'diagTxtPdte', v_data.C_UNID1, "", "text-right")
            ];

            var regEncontrado = false;
            function confirmComponent() {
                tabulado(dialogId);
                var tBody = $('#' + tableName + ' tbody');
                tBody.on('mousedown', componentData);
                tBody.on('click', function () { setQty(); $('#diagTxtCant').focus() });
                addComponent();
                diagTxtLote = $('#diagTxtLote');
                diagTxtUbic = $('#diagTxtUbic');

                // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
                //diagTxtUbic.keypress(function (e) {
                //    if (e.which == 13)
                diagTxtUbic.on("change", function (e) {
                    if (!diagTxtLote.is(':visible')) {
                        seleccionFila('#' + tableName, [{
                            KEY: "GAUBIC_COD", VALUE: diagTxtUbic.val()
                        }]);
                        setQty();
                    }
                });
                // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
                //diagTxtLote.keypress(function (e) {
                //    if (e.which == 13) {
                diagTxtLote.on("change", function (e) {
                    {
                        regEncontrado = $('#diagTxtUbic').is(':visible') ? seleccionFila('#' + tableName, [{ KEY: "GAUBIC_COD", VALUE: diagTxtUbic.val() }, { KEY: "LOTE", VALUE: diagTxtLote.val() }]) : seleccionFila('#' + tableName, [{ KEY: "LOTE", VALUE: diagTxtLote.val() }]);
                        setQty();
                    }
                })

                function setQty() {
                    if (isParentComponent)
                        $(diagTxtCant).val($('#diagTxtPdte').val());
                    else {
                        var diagDataTable = $('#' + tableName).DataTable();
                        if (diagDataTable.row('.selected').data().C_UNID1 < $('#diagTxtPdte').val()) {
                            $(diagTxtCant).val(diagDataTable.row('.selected').data().C_UNID1);
                        } else {
                            $(diagTxtCant).val($('#diagTxtPdte').val());
                        }
                    }
                }

                function componentData(e) {
                    var diagDataTable = $('#' + tableName).DataTable();
                    var selectedRow = diagDataTable.row(e.target);
                    $('#diagTxtUbic').val(diagDataTable.row(selectedRow).data().GAUBIC_COD);
                    $('#diagTxtLote').val(diagDataTable.row(selectedRow).data().LOTE);
                    $('#diagTxtCant').focus();
                }

                if (isParentComponent && typeof (Articulo.Componentes[v_row]) === 'undefined') {
                    Articulo.Componentes[v_row] = {
                        GAART_COD: v_data.GAART_COD,
                        C_UNID1: 0,
                        Lotes: [],
                    };
                } else {

                }
                var Comp;
                function addQty() {
                    console.log("Añadir Cantidad");
                    if ($('#diagTxtCant').val() != "") {
                        var table = $('#tablaUbic').DataTable();
                        var cant = TryParseFloat($('#diagTxtCant').val(), 0);
                        var encontrado = false;

                        if (isParentComponent && !regEncontrado) {

                            var row = [{ GAUBIC_COD: $('#diagTxtUbic').val(), LOTE: $('#diagTxtLote').val(), C_UNID1: 0 }];
                            table.rows.add(row).draw();
                            seleccionFila('#' + tableName, [{ KEY: "GAUBIC_COD", VALUE: diagTxtUbic.val() }, { KEY: "LOTE", VALUE: diagTxtLote.val() }])
                            $('tr.selected').click();
                            //table.row('.selected').click();
                        }
                        var row = table.row('.selected');
                        isParentComponent ? row.data().C_UNID1 += cant : row.data().C_UNID1 -= cant;
                        row.invalidate();
                        $('#diagTxtPdte').val(TryParseFloat($('#diagTxtPdte').val()) - cant);

                        Comp = isParentComponent ? Articulo : getComponentValues();
                        function getComponentValues() {
                            console.log("Obteniendo Componente");
                            if (typeof Comp === 'undefined')
                                Comp = JSON.parse(JSON.stringify(Articulo.Componentes[v_row]));
                            if (typeof Comp.Lotes === 'undefined') {
                                Comp.Lotes = [];
                            }
                            console.log("Cantidad Sumada al Componente");
                            Comp.C_UNID1 += cant;
                            Comp.C_UNID1 = JSON.parse(JSON.stringify(Articulo.Componentes[v_row])).C_UNID1 - $('#diagTxtPdte').val();
                            console.log("Componente Obtenido");
                            return Comp;
                        }

                        console.log("Buscando Componente...");
                        Comp.Lotes.forEach(function (exist) {
                            if (exist.Lote == $('#diagTxtLote').val() && exist.GAUBIC_COD == $('#diagTxtUbic').val()) {
                                console.log("Componente Encontrado");

                                encontrado = true;
                                exist.C_UNID1 += cant;
                            }
                        });
                        if (!encontrado) {
                            console.log("Componente No Encontrado");
                            Comp.Lotes.push({
                                LOTE: $('#diagTxtLote').val(),
                                GAUBIC_COD: $('#diagTxtUbic').val(),
                                C_UNID1: cant
                            });
                            console.log("Componente Generado");
                        }
                    } else {
                        console.log("Cantidad Vacía");
                    }
                    Articulo.Componentes[v_row] = Comp;
                    $('#diagTxtCant').val("");
                    console.log("Añadir Cantidad Finalizada");

                }

                function addComponent() {
                    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
                    //$('#diagTxtCant').keypress(function (e) {
                    //    if (e.which == 13) {
                    $('#diagTxtCant').on("change", function (e) {
                        {
                            addQty();
                        }
                    });
                }

                var btnReset = document.getElementById('btnReset');
                var btnAccept = document.getElementById('btnAccept');
                if (!isParentComponent)
                    addEvent(btnReset, 'click', resetData, false);
                addEvent(btnAccept, 'click', accept, false);
                function resetData() {
                    var table = $('#tablaUbic').DataTable();
                    table.rows().clear()
                    table.rows.add(v_datos_aux).draw();

                    Articulo.Componentes[v_row].Lotes = [];
                    //dataTable.row(v_row).data().C_UNID1 += Articulo.Componentes[v_row].C_UNID1;
                    dataTable.rows().invalidate();
                    Articulo.Componentes[v_row].C_UNID1 = 0;
                    $('#diagTxtPdte').val(dataTable.row(v_row).data().C_UNID1);
                }
                function accept() {
                    addQty();
                    closeModal('#dialogLoV');
                    getComponents(components);
                }
            }
            var v_datos_aux = JSON.parse(JSON.stringify(v_data.Lotes));
            generarDialogAuto(v_url, dialogId, tableName, null, v_data.Lotes, v_columns, v_buttons, v_inputs, v_upperInputs, confirmComponent, "Ubicaciones y lotes", null, compMessage);

        } else {
            montarKit();
        }

    }

    function resetCompData() {
        Articulo = JSON.parse(JSON.stringify(Articulo_aux));
        table.DataTable().clear().draw();
        table.DataTable().rows.add(Articulo.Componentes).draw();
        drawRows();
    }

    function generateTable() {
        var v_columns = [
            generateColumn("GAART_COD", Resources.table_head_article),
            generateColumn("GAART_DESCRIP", Resources.table_head_description),
            generateColumn("C_UNID1", Resources.table_head_quantity, true, true),
            generateColumn("GAUNITIP_COD1", "Un.")
        ];
        var columnDefs = [
            { className: "dt-right", targets: [2, 3] }
        ];
        createTableJson('#KitMontaje', null, v_columns, 6, null, columnDefs, false);
    };

    function buscaArticulo() {
        var url = "RF_Kits/Articulo";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            GAART_COD: $(txtArtCod).val()
        };
        var success = function (response) {
            if (response.Ok) {
                var obj = response.Objeto;
                clear();
                $(txtArtCod).val(obj.GAART_COD);
                $(txtArtDescrip).val(obj.GAART_DESCRIP);
                $(txtExistenciasAlmacen).val(obj.C_EXIST1);
                $(txtExistenciasAgrupadas).val(obj.C_EXIST1_ALMAGRU);

                Articulo.GAART_COD = obj.GAART_COD;
                Articulo.GAART_DESCRIP = obj.GAART_DESCRIP;
                Articulo.C_EXIST1 = obj.C_EXIST1;
                Articulo.C_EXIST1_ALMAGRU = obj.C_EXIST1_ALMAGRU;

            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
        }
        apiGeneral(url, method, data, success);
    }

    function obtenerComponentes() {

        var url = "RF_Kits/Componentes";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            GAART_COD: $(txtArtCod).val(),
            C_UNID1: $(txtCant).val()
        };
        Articulo.C_UNID1 = $(txtCant).val();

        var success = function (response) {
            table.DataTable().clear().draw();
            if (response.Ok) {
                var obj = response.Objeto;
                table.DataTable().rows.add(obj).draw();
                drawRows();
            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
        };
        apiGeneral(url, method, data, success);
    }

    function drawRows() {
        dataTable.rows().every(function (rowIdx, tableLoop, rowLoop) {
            var data = this.data();
            if (data.EXIST_SUF == "S") {
                $(this.node()).removeClass('red');
            } else {
                $(this.node()).addClass('red');
            }
        });
    }

    function modCellValue() {
        var col = 2;

        $(dataTable.table().container()).on('click', 'td', function () {
            if (!$(this).find('input').length) {
                var cell = dataTable.cell(this);
                var columns = dataTable.settings().init().aoColumns;

                var index = cell.index();
                var $cell = $(this);

                if (CONFIG.PERMITE_MODIF_CANT_COMP && columns[index.column].mDataProp == 'C_UNID1') {
                    var C_UNID1 = $cell.context.innerHTML;
                    $cell.context.innerHTML = '<input id="modInput" class="col-xs-12 text-right modInput" value="' + C_UNID1 + '" />';
                    $('.modInput').focus().select();
                    $('.modInput').on('click', function () {
                        $(this).select();
                    });
                    $('.modInput').on('blur', function () {
                        var data = dataTable.row(index.row).data();
                        data.C_UNID1 = TryParseInt($(this).val(), C_UNID1);
                        dataTable.row(index.row).invalidate();
                        var data = dataTable.row(index.row).data();
                        drawRows();
                    });
                }
            }
        });
    }

    function obtenUbicaciones() {
        var url = "montaje/obtenUbicaciones";
        var method = "GET";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GAART_COD: $(txtArtCod).val() }
        var success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = 'Dialog/Dialog';
                var columns = [generateColumn('GAUBIC_COD', Resources.table_head_code)];
                var buttons = [generateSingleButton('aceptar', Resources.button_accept)]

                function recogeUbicacion() {
                    var btnAccept = document.getElementById('aceptar');
                    addEvent(btnAccept, 'click', recogeUbic);

                    var table = $('#ubicTable').DataTable();

                    function recogeUbic() {
                        if (table.rows().data().length != 0) {
                            txtUbicacionDest.val(table.rows('.selected').data()[0].GAUBIC_COD);
                        }
                        closeModal('#dialogLoV');
                    }
                }
                generarDialogAuto(url, "#dialogLoV", "ubicTable", null, response.Objeto, columns, buttons, null, null, recogeUbicacion, "Ubicaciones");
            } else {
                lanzarMensaje(false, response.Mensaje);
            }
        }
        apiGeneral(url, method, datos, success);
    }

    function obtenLotes() {
        var url = "montaje/obtenLotes";
        var method = "GET";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GAART_COD: $(txtArtCod).val() }
        var success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var columns = [generateColumn('LOTE', Resources.table_head_batch)];
                var buttons = [generateSingleButton('aceptar', Resources.button_accept)]

                function recogeLote() {
                    var btnAccept = document.getElementById('aceptar');
                    addEvent(btnAccept, 'click', recogeLot);
                    var table = $('#ubicTable').DataTable();
                    function recogeLot() {
                        if (table.rows().data().length != 0) {
                            txtLoteDest.val(table.rows('.selected').data()[0].GAUBIC_COD);
                        }
                        closeModal('#dialogLoV');
                    }
                }

                generarDialogAuto(url, "#dialogLoV", "LoteTable", null, response.Objeto, columns, buttons, null, null, recogeLote, "Lotes");
            } else {
                lanzarMensaje(false, response.Mensaje);
            }
        }
        apiGeneral(url, method, datos, success);
    }
});