﻿const SI = "S";
const NO = "S";

// Input[type=text]
const txtAlbaran = document.getElementById('txtAlbaran');
const txtFecha = document.getElementById('txtFecha');
const txtCliente = document.getElementById('txtCliente');

const btnLimpiar = document.getElementById("btnLimpiar");
const btnActivar = document.getElementById("btnActivar");

const btnConfirmar = document.getElementById("btnConfirmar");
const btnImprimir = document.getElementById("btnImprimir");

const txtTransportista = document.getElementById("codTransportistaInput");
const btnTransportistaSearch = document.getElementById("transporterSearch");
const txtTransportistaNombre = document.getElementById("nombreTransportistaInput");

const txtCodVehiculo = document.getElementById("codVehiculoInput");
const btnVehicleSearch = document.getElementById("vehicleSearch");
const txtDescrVehiculo = document.getElementById("descrVehiculoInput");


const txtBultos = document.getElementById("bultosInput");
const txtPeso = document.getElementById("pesoInput");
const txtEtiquetas = document.getElementById("etiquetasInput");
const selectType = document.getElementById("selectType");
const txtCopias = document.getElementById("CopiasInput");
const chkAlbaranVal = document.getElementById("chkAlbaranVal");
//const btnEnvioAceptarBultos = document.getElementById("envioAceptarBultos");


// Tabla
const tablaDatosAlbaran = document.getElementById('tablaDatosAlbaran');
var $dataTable = createTable();
const DataTable = $(tablaDatosAlbaran).DataTable();

function createTable() {
    if (!$dataTable) {
        var v_columns = [
            generateColumn("GAART_COD", Resources.table_head_article),
            generateColumn("DESCRIP", Resources.table_head_description),
            generateColumn("C_UNI1", Resources.table_head_quantity, true, true)
        ];

        var columnDefs = [
            { "width": "4em", "targets": 0 },
            { "width": "6em", "targets": 1 },
            { "width": "1em", "targets": 2 }
        ];

        createTableJson("#" + tablaDatosAlbaran.id, null, v_columns, 6, null, columnDefs, false);

        return $(tablaDatosAlbaran).dataTable();
    } else {
        return $dataTable;
    }
}

class Linea {
    constructor() {
        this.GAART_COD = "";
        this.GAART_DESCRIP = "";
        this.C_UNI1 = 0;
        this.C_UNI2 = 0;
    }
}
var AlbaranInstance;
class Albaran {
    constructor() {
        this.EMPGRUPO_COD = sessionStorage.getItem("EMPRGRUP_COD");
        this.EMP_COD = sessionStorage.getItem("EMPR_COD");

        this.GGALBTIP_COD = "";
        this.N_ALBARAN = "";
        this.Albaran = "";
        this.FECHA = "";
        this.GGCLIPR_NOM = "";

        this.GGMENVIO_COD = "";
        this.GGMENVIO_DESCRIP = "";
        this.GGVEHICULO_COD = "";
        this.GGVEHICULO_DESCRIP = "";

        this.N_BULTOS = 0;
        this.N_ETIQUETAS = 0;
        this.PESO = 0;
        this.Opciones = new Array();
        this.OpcionPredeterminada = "";
        this.MostrarAlbaranValorado = false;
        this.AlbaranValorado = false;


        this.Parametros = {};

        this.Lineas = new Array();

        this.inicializa();
    }

    inicializa() {
        // vacio
    }

    static Instance() {
        if (!AlbaranInstance) {
            AlbaranInstance = new Albaran();
        }
        return AlbaranInstance;
    }

    UpdateValues() {
        this.Albaran = $(txtAlbaran).val();

        this.FECHA = $(txtFecha).val();
        this.GGCLIPR_NOM = $(txtCliente).val();

        this.GGMENVIO_COD = $(txtTransportista).val();
        this.GGMENVIO_DESCRIP = $(txtTransportistaNombre).val();
        this.GGVEHICULO_COD = $(txtCodVehiculo).val();
        this.GGVEHICULO_DESCRIP = $(txtDescrVehiculo).val();
        this.N_BULTOS = $(txtBultos).val();
        this.PESO = $(txtPeso).val();
        this.Copias = $(txtCopias).val();
        this.N_ETIQUETAS = $(txtEtiquetas).val();
        // RBM this.AlbaranValorado = $(chkAlbaranVal).val();
        this.AlbaranValorado = $(chkAlbaranVal).is(':checked');
        this.OpcionPredeterminada = $(selectType).val();

    }

    UpdateView() {
        console.log("UPDATE VIEW")
        $(txtAlbaran).val(this.Albaran);
        $(txtFecha).val(this.FECHA);
        $(txtCliente).val(this.GGCLIPR_NOM);

        $(txtTransportista).val(this.GGMENVIO_COD);
        $(txtTransportistaNombre).val(this.GGMENVIO_DESCRIP);
        $(txtCodVehiculo).val(this.GGVEHICULO_COD);
        $(txtDescrVehiculo).val(this.GGVEHICULO_DESCRIP);
        $(txtBultos).val(this.N_BULTOS);
        $(txtPeso).val(this.PESO);
        $(txtCopias).val(this.Copias);
        $(txtEtiquetas).val(this.N_ETIQUETAS);
        // RBM $(chkAlbaranVal).val(this.AlbaranValorado);
        $(chkAlbaranVal).prop('checked', this.AlbaranValorado);
        $(selectType).val(this.OpcionPredeterminada);

    }

    UpdateTable() {
        DataTable.clear();
        console.log(this.Lineas);
        DataTable.rows.add(this.Lineas).draw();
    }

    Assign(Object) {
        this.GGALBTIP_COD = Object.GGALBTIP_COD;
        this.N_ALBARAN = Object.N_ALBARAN;
        this.FECHA = Object.FECHA;
        this.GGCLIPR_NOM = Object.GGCLIPR_NOM;
        this.Albaran = Object.Albaran;
        this.Lineas = Object.Lineas;

        this.GGMENVIO_COD = Object.GGMENVIO_COD;
        this.GGMENVIO_DESCRIP = Object.GGMENVIO_DESCRIP;
        this.GGVEHICULO_COD = Object.GGVEHICULO_COD;
        this.GGVEHICULO_DESCRIP = Object.GGVEHICULO_DESCRIP;

        this.Copias = Object.Copias;

        this.N_BULTOS = Object.N_BULTOS;
        this.N_ETIQUETAS = Object.N_ETIQUETAS;
        this.PESO = Object.PESO;
        this.Opciones = Object.Opciones;
        this.OpcionPredeterminada = Object.OpcionPredeterminada;
        this.MostrarAlbaranValorado = Object.MostrarAlbaranValorado;
        this.AlbaranValorado = Object.AlbaranValorado;
    }

    DameDatosAlbaran() {
        var self = this;
        var url = "Expedicion/AlbaranPendiente";
        var method = "GET";
        var data = {
            emp_cod: this.EMP_COD,
            empgrupo_cod: this.EMPGRUPO_COD,
            lecturaalbaran: this.Albaran
        };
        var success = function (response) {
            var Ok = function () {
                var obj = response.Objeto;
                // Asignamos el Albaran al objeto recibido para no perderlo al realizar el Assign.
                obj.Albaran = self.Albaran;
                self.Assign(obj);
                self.UpdateView();
                self.UpdateTable();
            };
            var Error = function () {

            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }

    Activar() {
        var self = this;
        self.ImprimirEtiquetas = false;
        if (self.GGALBTIP_COD && self.N_ALBARAN) {
            lanzarConfirmacion("¿Desea cambiar el estado del albarán de Pendiente a Activo y cambiar la fecha del " + self.FECHA + " a " + moment(new Date()).format("DD/MM/YY") + "?", function () { self.CambiarEstadoAlbaran(); });
        } else {
            lanzarMensaje(false, "Debe introducir un albarán.", function () { $(txtAlbaran).focus(); });
        }
    }

    ActivarImpresion() {
        var self = this;
        self.ImprimirEtiquetas = true;
        if (self.GGALBTIP_COD && self.N_ALBARAN) {
            lanzarConfirmacion("¿Desea cambiar el estado del albarán de Pendiente a Activo y cambiar la fecha del " + self.FECHA + " a " + moment(new Date()).format("DD/MM/YY") + "?", function () { self.CambiarEstadoAlbaran(); });
        } else {
            lanzarMensaje(false, "Debe introducir un albarán.", function () { $(txtAlbaran).focus(); });
        }
    }

    CambiarEstadoAlbaran() {
        var self = this;
        self.UpdateValues();
        var url = "Expedicion/CambiarEstadoAlbaran";
        var method = "POST";
        var data = {
            EMPGRUPO_COD: self.EMPGRUPO_COD,
            EMP_COD: self.EMP_COD,
            GGALBTIP_COD: self.GGALBTIP_COD,
            N_ALBARAN: self.N_ALBARAN,
            Parametros: self.Parametros,
            GGMENVIO_COD: self.GGMENVIO_COD,
            GGVEHICULO_COD: self.GGVEHICULO_COD,
            ImprimirEtiquetas: self.ImprimirEtiquetas,
            ImprimirValorado: self.AlbaranValorado,
            N_BULTOS: self.N_BULTOS,
            PESO: self.PESO,
            N_ETIQUETAS: self.N_ETIQUETAS,
            OpcionEtiquetas: self.OpcionEtiquetas


        };
        var success = function (response) {

            var Ok = function () {
                var obj = response.Objeto;

                var confirmarCambio = function () {
                    //showDialog("#dialogEnviosEtiquetas");
                    successMessage("Cambio Realizado");
                    self.Clear();
                };
                if (obj.Parametros) {
                    if (obj.Parametros.P_PREGUNTA) {
                        self.PreguntaCambioEstado(obj);
                    }
                    else {
                        confirmarCambio();
                    }
                } else {
                    confirmarCambio();
                }
            };
            var Error = function () {

            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }

    Clear() {
        this.Assign(new Albaran());
        this.UpdateView();
        this.UpdateTable();
        closeModal("#dialogEnviosEtiquetas");
        $(txtAlbaran).focus();
    }

    PreguntaCambioEstado(obj) {
        var self = this;
        var acceptFn = function () {
            obj.Parametros.P_RESPUESTA = "S";
            self.Parametros = obj.Parametros;
            self.CambiarEstadoAlbaran();
            closeModal('#dialogLoV');
        };
        var cancelFn = function () {
            obj.Parametros.P_RESPUESTA = "N";
            self.Parametros = obj.Parametros;
            self.CambiarEstadoAlbaran();
            closeModal('#dialogLoV');
        };
        //lanzarConfirmacion(response.Objeto.PREGUNTA_HIST, acceptFn, cancelFn);
        var btnFunctions = function () {
            $("#btnPHSi").on("click", acceptFn);
            $("#btnPHNo").on("click", cancelFn);
        };
        //var url = Router.action('Dialog', 'Dialog');
        var url = 'Dialog/Dialog';
        var buttons = [
            generateSingleButton("btnPHSi", "Sí", "pull-right", "default col-xs-3"),
            generateSingleButton("btnPHNo", "No", "pull-left", "gray col-xs-3")
        ];
        generarDialogAuto(url, "#dialogLoV", null, null, null, null, buttons, null, null, btnFunctions, "Mensaje", null, obj.Parametros.P_PREGUNTA);
    }

    ValidarModoEnvio() {
        var self = this;
        self.UpdateValues();
        var url = "/Expedicion/ModoEnvio";
        var method = "GET";
        var data = {
            ggmenvio_cod: $(txtTransportista).val()
        };
        var success = function (response) {
            var Ok = function () {
                self.GGMENVIO_COD = response.Objeto.COD;
                self.GGMENVIO_DESCRIP = response.Objeto.DESCRIP;
                self.GGVEHICULO_COD = "";
                self.GGVEHICULO_DESCRIP = "";
                self.UpdateView();
                self.FocusVehiculo();
            };
            var Error = function () {
                self.GGMENVIO_COD = "";
                self.GGMENVIO_DESCRIP = "";
                self.GGVEHICULO_COD = "";
                self.GGVEHICULO_DESCRIP = "";
                self.UpdateView();
                self.FocusTransportista();
            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }

    ListadoModosEnvio() {
        var self = this;
        var url = "/Expedicion/ModosEnvio";
        var method = "GET";
        var data = {
            emp_cod: this.EMP_COD,
            empgrupo_cod: this.EMPGRUPO_COD
        };
        var success = function (response) {
            var Ok = function () {
                var v_dialog = "#dialogLoV";
                var v_nombre_tabla = 'tablaTransportista';
                var v_column = [{ "mDataProp": "COD", name: 'Código' }, { "mDataProp": "DESCRIP", name: 'Nombre' }];
                //var url = Router.action('Dialog', 'Dialog');
                var url = 'Dialog/Dialog';
                var buttons = [{ id: 'select', value: 'Seleccionar' }];
                var func = function () {
                    $('#select').on('click', function () {
                        var v_table = $("#tablaTransportista").DataTable();
                        if (v_table.rows().data().length > 0) {
                            self.GGMENVIO_COD = v_table.rows('.selected').data()[0].COD;
                            self.GGMENVIO_DESCRIP = v_table.rows('.selected').data()[0].DESCRIP;
                            self.GGVEHICULO_COD = "";
                            self.GGVEHICULO_DESCRIP = "";
                            self.UpdateView();
                            self.FocusVehiculo();
                        }
                        closeModal('#dialogLoV');
                    });
                };
                generarDialogAuto(url, v_dialog, v_nombre_tabla, null, response.Objeto, v_column, buttons, null, null, func, "Transportistas", null, null, null, null, null, null, null, true);
            };

            var Error = function () {
                $(txtTransportista).focus().select();
            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }

    ValidarVehiculo() {
        var self = this;
        self.UpdateValues();
        var url = "/Expedicion/Vehiculo";
        var method = "GET";
        var data = {
            ggmenvio_cod: self.GGMENVIO_COD,
            cod: $(txtCodVehiculo).val()
        };
        var success = function (response) {
            var Ok = function () {
                self.GGVEHICULO_COD = response.Objeto.COD;
                self.GGVEHICULO_DESCRIP = response.Objeto.DESCRIP;
                self.UpdateView();
                self.FocusBultos();
            };
            var Error = function () {
                self.FocusVehiculo();
            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }

    ListadoVehiculos() {
        var self = this;
        var url = "/Expedicion/Vehiculos";
        var method = "GET";
        var data = {
            ggmenvio_cod: self.GGMENVIO_COD
        };
        var success = function (response) {
            var Ok = function () {
                var v_dialog = "#dialogLoV";
                var v_nombre_tabla = 'tablaTransportista';
                var v_column = [{ "mDataProp": "COD", name: 'Código' }, { "mDataProp": "DESCRIP", name: 'Nombre' }];
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var buttons = [{ id: 'select', value: 'Seleccionar' }];
                var func = function () {
                    $('#select').on('click', function () {
                        var v_table = $("#tablaTransportista").DataTable();
                        if (v_table.rows().data().length > 0) {
                            self.GGVEHICULO_COD = v_table.row('.selected').data().COD;
                            self.GGVEHICULO_DESCRIP = v_table.row('.selected').data().DESCRIP;
                            self.FocusBultos();
                            self.UpdateView();
                        }
                        closeModal('#dialogLoV');
                    });
                };
                generarDialogAuto(url, v_dialog, v_nombre_tabla, null, response.Objeto, v_column, buttons, null, null, func, "Transportistas", null, null, null, null, null, null, null, true);
            };

            var Error = function () {
                self.FocusVehiculo();
            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }

    FocusTransportista() {
        $(txtTransportista).focus().select();
    }

    FocusVehiculo() {
        $(txtCodVehiculo).focus().select();
    }

    FocusBultos() {
        $(txtBultos).focus().select();
    }

    FocusPeso() {
        $(txtPeso).focus().select();
    }

    FocusPlantilla() {
        $(selectType).focus().select();
    }

    FocusCopias() {
        $(txtCopias).focus().select();
    }

    FirstFocusBultos() {
        FocusTransportista();
    }

    ObtenerDatosBultos() {
        var self = this;
        var url = "/Expedicion/ResumenBultosAlbaranPendiente";
        var method = "PUT";
        var data = {
            emp_cod: this.EMP_COD,
            empgrupo_cod: this.EMPGRUPO_COD,
            GGALBTIP_COD: this.GGALBTIP_COD,
            N_ALBARAN: this.N_ALBARAN,
            Lineas: this.Lineas
        };
        var success = function (response) {
            var Ok = function () {
                self.GGMENVIO_COD = response.Objeto.GGMENVIO_COD;
                self.GGMENVIO_DESCRIP = response.Objeto.GGMENVIO_DES;
                self.GGVEHICULO_COD = response.Objeto.GGVEHICULO_COD;
                self.GGVEHICULO_DESCRIP = response.Objeto.GGVEHICULO_DES;
                self.N_BULTOS = response.Objeto.N_BULTOS;
                self.N_ETIQUETAS = response.Objeto.N_ETIQUETAS;
                self.PESO = response.Objeto.PESO;
                self.Opciones = response.Objeto.Opciones;
                self.OpcionPredeterminada = response.Objeto.OpcionPredeterminada;
                self.MostrarAlbaranValorado = response.Objeto.MostrarAlbaranValorado;
                self.AlbaranValorado = response.Objeto.AlbaranValorado;

                if (self.MostrarAlbaranValorado)
                    $("#AlbValContainer").show();
                else
                    $("#AlbValContainer").hide();

                $(selectType).empty();
                $.each(self.Opciones, function (i, Obj) {
                    $(selectType).append($('<option>', {
                        value: Obj,
                        text: Obj
                    }));
                });

                showDialog("#dialogEnviosEtiquetas");
                self.FirstFocusBultos();
                self.UpdateView();
            };
            var Error = function () { };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }
}

$(document).ready(function () {
    var vAlbaran = Albaran.Instance();
    addEvent(btnLimpiar, "click", function () { vAlbaran.Clear(); }, false);
    addEvent(btnActivar, "click", function () { vAlbaran.ObtenerDatosBultos(); }, false);
    //addEvent(btnEnvioAceptarBultos, "click", function () { vAlbaran.Imprimir(); }, false);
    addEvent(btnTransportistaSearch, "click", function () { vAlbaran.ListadoModosEnvio(); }, false);
    addEvent(btnVehicleSearch, "click", function () { vAlbaran.ListadoVehiculos(); }, false);

    addEvent(btnConfirmar, "click", function () { vAlbaran.Activar(); }, false);
    addEvent(btnImprimir, "click", function () { vAlbaran.ActivarImpresion(); }, false);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtTransportista).keypress(function (e) { if (e.which === 13) { vAlbaran.ValidarModoEnvio(); } });
    //$(txtAlbaran).keypress(function (e) { if (e.which === 13) { vAlbaran.UpdateValues(); vAlbaran.DameDatosAlbaran(); } });
    //$(txtCodVehiculo).keypress(function (e) { if (e.which === 13) { vAlbaran.ValidarVehiculo(); } });

    //$(txtBultos).keypress(function (e) { if (e.which === 13) { vAlbaran.FocusPeso(); } });
    //$(txtPeso).keypress(function (e) { if (e.which === 13) { vAlbaran.FocusPlantilla(); } });
    //$(selectType).keypress(function (e) { if (e.which === 13) { vAlbaran.FocusCopias(); } });
    //$(txtCopias).keypress(function (e) { if (e.which === 13) { vAlbaran.FirstFocusBultos(); } });
    $(txtTransportista).on("change", function (e) { vAlbaran.ValidarModoEnvio(); });
    $(txtAlbaran).on("change", function (e) { vAlbaran.UpdateValues(); vAlbaran.DameDatosAlbaran(); });
    $(txtCodVehiculo).on("change", function (e) { vAlbaran.ValidarVehiculo(); });

    //$(txtBultos).on("change", function (e) { vAlbaran.FocusPeso(); });
    //$(txtPeso).on("change", function (e) { vAlbaran.FocusPlantilla(); });
    //$(selectType).on("change", function (e) { vAlbaran.FocusCopias(); });
    //$(txtCopias).on("change", function (e) { vAlbaran.FirstFocusBultos(); });

});