﻿define('expedicion-bultos', ['expedicion-ubicaciones'],
    function (Expedicion) {

        Expedicion.prototype.FuncionesBultos = function () {
            this./*exp*/dialogOpening = false;
            if (this./*exp*/bulto.length > 0) {
                $('#bultoDetail').prop('disabled', false);
                $('#bultoSelec').prop('disabled', false);
            } else {
                $('#bultoDetail').prop('disabled', true);
                $('#bultoSelec').prop('disabled', true);
            }

            $('#dialogPedidos2 .close').on("click", function (e) {
                closeModal("#dialogPedidos2");
                e.preventDefault();
                e.stopPropagation();
                return false;

            });

            $('#bultoDetail').on("click", (function () {
                var v_tabla = $('#tablaBultos').DataTable();
                var v_idBulto = eval(v_tabla.rows('.selected').data()[0].N_BULTO);
                var v_columnas = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description), generateColumn('C_UNI1', Resources.table_head_quantity, true, true)];
                var columnDefs = [
                    { "width": "6em", "targets": 0 },
                    { "width": "4em", "targets": 2 }
                ];
                //var url = Router.action('Dialog', 'Dialog');
                var url = 'Dialog/Dialog';
                var buttons = [generateSingleButton('detBultoAceptar', Resources.button_accept)];
                generarDialogAuto(url, "#dialogBultoDetail", 'tablaDetallesBulto', null, this./*exp*/bulto[v_idBulto - 1]['v_articulos'], v_columnas, buttons, null, null, this./*exp*/DetallesBulto, Resources.title_packages, null, null, null, Resources.zeroRecordsMessage, null, null, columnDefs);
            }).bind(this));

            $('#bultoNuevo').on("click", (function () {
                var url = "expedicion/tipospale";
                var method = "GET";
                var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") };
                var success = function (response) {
                    var Ok = (function () {
                        //var url = Router.action('Dialog', 'Dialog');
                        var url = 'Dialog/Dialog';
                        var v_data = response.Objeto;
                        var v_columnas = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
                        var columnDefs = [
                            { "width": "6em", "targets": 0 }
                        ];
                        var buttons = [generateSingleButton('tipoBultoSelec', Resources.button_select)];
                        generarDialogAuto(url, "#dialogBultoNuevo", 'tablaTiposBulto', null, v_data, v_columnas, buttons, null, null, this./*exp*/BultoNuevo, Resources.title_packages_new, null, null, null, Resources.zeroRecordsMessage, null, null, columnDefs);
                    }).bind(this);
                    handleResponse(response, Ok);
                };
                apiGeneral(url, method, datos, success);
            }).bind(this));

            $('#bultoNing').on("click", (function () {
                this./*exp*/RecogerDetalles();
                closeModal("#dialogPedidos2");
                closeModal("#dialogLoV");
            }).bind(this));

            $('#bultoSelec').on("click", (function () {
                var v_tabla = $('#tablaBultos').DataTable();
                this./*exp*/SeleccionBulto(v_tabla.rows('.selected').data()[0].N_BULTO);

                this./*exp*/RecogerDetalles();
                closeModal("#dialogPedidos2");
                closeModal("#dialogLoV");
            }).bind(this));
        };

        Expedicion.prototype.FuncionesBultosDetail = function () {
            if (this./*exp*/bulto.length > 0) {
                $('#bultoDetailMenu').prop('disabled', false);
            } else {
                $('#bultoDetailMenu').prop('disabled', true);
            }
            $('#bultoDetailMenu').on("click", (function () {
                var v_tabla = $('#tablaBultosDetail').DataTable();
                var v_idBulto = eval(v_tabla.rows('.selected').data()[0].N_BULTO);
                var v_columnas = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description), generateColumn('C_UNI1', Resources.table_head_quantity, true, true)];
                var columnDefs = [
                    { "width": "6em", "targets": 0 },
                    { "width": "4em", "targets": 2 }
                ];
                //var url = Router.action('Dialog', 'Dialog');
                var url = 'Dialog/Dialog';

                var buttons = [generateSingleButton('detBultoAceptarMenu', Resources.close)];

                generarDialogAuto(url, "#dialogBultoDetailMenu", 'tablaDetallesBulto1', null, this./*exp*/bulto[v_idBulto - 1]['v_articulos'], v_columnas, buttons, null, null, this./*exp*/DetallesBultoMenu, Resources.packages, null, null, null, null, null, null, columnDefs);
            }).bind(this));

            $('#closeDetailMenu').on('click', function () {
                closeModal("#dialogLoV");
            });
        };

        Expedicion.prototype.DetallesBultoMenu = function () {
            $("#dialogBultoDetailMenu .close").on("click", function (event) {
                closeModal("#dialogBultoDetailMenu");
                event.preventDefault();
                event.stopPropagation();
                return false;
            });

            $("#detBultoAceptarMenu").on("click", function () {
                closeModal("#dialogBultoDetailMenu");
            });
        };


        Expedicion.prototype.DetallesBulto = function () {
            $("#dialogBultoDetail .close").on("click", function (event) {
                closeModal("#dialogBultoDetail");
                $("#campRefer").focus().select();
                event.preventDefault();
                event.stopPropagation();
                return false;
            });

            $("#detBultoAceptar").on("click", function () {
                closeModal("#dialogBultoDetail");
            });
        };

        Expedicion.prototype.BultoNuevo = function () {
            $("#dialogBultoNuevo .close").on("click", function (event) {
                closeModal("#dialogBultoNuevo");
                event.preventDefault();
                event.stopPropagation();
                return false;
            });

            $("#tipoBultoSelec").on("click", (function () {
                this./*exp*/NuevoBulto();
                this./*exp*/RecogerDetalles();
                closeModal("#dialogBultoNuevo");
                closeModal("#dialogPedidos2");
                closeModal("#dialogLoV");
            }).bind(this));
        };

        Expedicion.prototype.RecogerDatos = function () {
            this./*exp*/v_orden_exp = {
                EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
                EMP_COD: sessionStorage.getItem("EMPR_COD"),
                GGPEDTIP_COD: this./*exp*/data.GGPEDTIP_COD,
                N_PEDIDO: this./*exp*/data.N_PEDIDO,
                GGMENVIO_COD: $('#codTransporte').val(),
                GGVEHICULO_COD: $("#codVehiculo").val(),
                GGALBTIP_COD: $("#tipoAlbaran").val(),
                N_ALBARAN: $("#numAlbaran").val(),
                F_ALBARAN: getFechaAlbaran(),
                N_BULTOS: this./*exp*/bulto.length,
                Bultos: this./*exp*/bulto,
                LINEAS: this./*exp*/v_lineas_pedido
            };
        };


        Expedicion.prototype.RecogerDetalles = function () {
            for (i = 0; i < this./*exp*/v_lineas_pedido.length; i++) {
                if (!this./*exp*/v_lineas_pedido[i]["Detalles"]) {
                    this./*exp*/v_lineas_pedido[i]["Detalles"] = new Array();
                }
                for (j = 0; j < this./*exp*/detallesProd.length; j++) {
                    if (this./*exp*/v_lineas_pedido[i].N_LIN === eval(this./*exp*/detallesProd[j].id)) {
                        if (!this./*exp*/Repetido(i) && (this./*exp*/detallesProd[j].GAUBIC_COD || this./*exp*/detallesProd[j].LOTE)) {
                            this./*exp*/v_lineas_pedido[i]["Detalles"].push(this./*exp*/detallesProd[j]);
                        }
                        if (!this./*exp*/v_lineas[i].C_PDTE) {
                            this./*exp*/v_lineas[i].C_PDTE = eval(this./*exp*/detallesProd[j].C_UNI1);
                        } else {
                            this./*exp*/v_lineas_pedido[i]['C_UNI1'] = this./*exp*/v_lineas_pedido[i]['C_UNI1'] + eval(this./*exp*/detallesProd[j].C_UNI1);
                        }
                        encontrado = true;
                    }
                }
            }
            var pos_v_lineas;
            var encontrado = false;

            this./*exp*/data = JSON.parse(JSON.stringify(this./*exp*/v_dataClon));

            for (i = 0; i < this./*exp*/v_lineas.length && !encontrado; i++) {
                if (this./*exp*/data.Lineas[i].N_LIN === $('#tablaPedidos').DataTable().rows('#' + this./*exp*/v_posicion_pedido).data()[0].N_LIN) {
                    pos_v_lineas = i;
                    encontrado = true;
                }
            }


            var v_table = $('#tablaPedidos').DataTable();
            v_table.row('#' + this./*exp*/v_posicion_pedido).data(this./*exp*/data.Lineas[pos_v_lineas]).draw();
            this./*exp*/CambioColorPedido(this./*exp*/v_lineas_pedido);
            this./*exp*/ActualizarBultos();
            $("#campRefer").focus().select();
        };

        Expedicion.prototype.CambioColorPedido = function (v_lineas_pedido) {
            var v_table = $('#tablaPedidos').DataTable();
            var row = v_table.row('#' + this./*exp*/v_posicion_pedido).node();

            for (i = 0; i < v_lineas_pedido.length; i++) {
                if (v_lineas_pedido[i].N_LIN === this./*exp*/v_posicion_pedido && v_lineas_pedido[i].C_UNI1 !== 0) {
                    if (!$(row).hasClass('green')) {
                        $(row).addClass('green');
                    }
                    return;
                }
            }
        };


        Expedicion.prototype.Repetido = function (i) {
            for (k = 0; k < this./*exp*/v_lineas_pedido[i]["Detalles"].length; k++) {
                if (this./*exp*/detallesProd[j]['LOTE'] === this./*exp*/v_lineas_pedido[i]["Detalles"][k]['LOTE'] && this./*exp*/detallesProd[j]['GAUBIC_COD'] === this./*exp*/v_lineas_pedido[i]["Detalles"][k]['GAUBIC_COD']) {
                    this./*exp*/v_lineas_pedido[i]["Detalles"][k]['C_UNI1'] = eval(this./*exp*/v_lineas_pedido[i]["Detalles"][k]['C_UNI1']) + eval(this./*exp*/detallesProd[j]['C_UNI1']);
                    return true;
                }
            }
            return false;
        };

        Expedicion.prototype.SeleccionBulto = function (numBulto) {
            this./*exp*/GenerarBulto(numBulto);
        };

        Expedicion.prototype.NuevoBulto = function () {
            this./*exp*/GenerarBulto(null);
        };

        Expedicion.prototype.GenerarBulto = function (numBulto) {
            var v_articulos = new Array();
            var v_NUM_Pedido = this./*exp*/v_dataClon.N_PEDIDO;
            var v_cantidad = this./*exp*/v_pedidoActual_cant;
            var v_tablaPed = $('#tablaPedidos').DataTable();
            this./*exp*/v_descr_articulo = v_tablaPed.rows('#' + this./*exp*/v_posicion_pedido).data()[0].GAART_COD;
            this./*exp*/v_nombre_articulo = v_tablaPed.rows('#' + this./*exp*/v_posicion_pedido).data()[0].GAART_DESCRIP;
            if (!numBulto) {
                this./*exp*/v_numBulto = this./*exp*/v_numBulto + 1;
                v_tablaTiposBulto = $('#tablaTiposBulto').DataTable();
                v_tipoBulto = v_tablaTiposBulto.rows('.selected').data()[0].COD;
                v_articulos.push({ N_BULTO: this./*exp*/v_numBulto, GGPEDLIN_N_LIN: this./*exp*/v_posicion_pedido, GAART_COD: this./*exp*/v_descr_articulo, C_UNI1: this./*exp*/v_pedidoActual_cant, GAART_DESCRIP: this./*exp*/v_nombre_articulo });
                this./*exp*/bulto.push({ N_BULTO: this./*exp*/v_numBulto, v_NUM_Pedido: v_NUM_Pedido, v_numBulto: this./*exp*/v_numBulto, v_tipoBulto: v_tipoBulto, v_articulos: v_articulos, v_cantidad: v_cantidad });
            } else {
                this./*exp*/v_numBulto = numBulto;
                v_articulos.push({ N_BULTO: this./*exp*/v_numBulto, GGPEDLIN_N_LIN: this./*exp*/v_posicion_pedido, GAART_COD: this./*exp*/v_descr_articulo, C_UNI1: this./*exp*/v_pedidoActual_cant, GAART_DESCRIP: this./*exp*/v_nombre_articulo });
                this./*exp*/AddBulto(numBulto, v_articulos[0]);
            }
        };

        Expedicion.prototype.AddBulto = function (numBulto, articulos) {
            var encontrado = false;
            numBulto = numBulto - 1;
            var v_articulosBulto = this./*exp*/bulto[eval(numBulto)]["v_articulos"];
            for (var i = 0; i < v_articulosBulto.length && !encontrado; i++) {
                if (v_articulosBulto[i]["GGPEDLIN_N_LIN"] === articulos['GGPEDLIN_N_LIN']) {
                    v_articulosBulto[i]["C_UNI1"] = v_articulosBulto[i]["C_UNI1"] + articulos['C_UNI1'];
                    encontrado = true;
                }
            }
            if (!encontrado) {
                this./*exp*/bulto[numBulto]["v_articulos"].push(articulos);
            }
            this./*exp*/bulto[numBulto]['v_cantidad'] = this./*exp*/bulto[numBulto]['v_cantidad'] + this./*exp*/v_pedidoActual_cant;
            this./*exp*/RecogerDatos();
        };

        return Expedicion;
    });