﻿define('expedicion-base', ['domReady!', 'componentes', 'dialogo-lotes-ubicaciones'],
    function (documento, { boton, campo, mensaje, modal }, DialogoLotesUbicaciones) {

        $(window).resize(function () {
            resizePedidos();
        });

        function resizePedidos() {
            if ($(window).width() < 400) {
                $('#ref .sinLote label').removeClass('col-xs-12').addClass('col-xs-2');

            } else {
                $('#ref .sinLote label').removeClass('col-xs-2').addClass('col-xs-12');
            }
        }

        function Expedicion() {
            this.v_tabla;
            this.data;
            this.v_dataClon;
            this.detallesProd = [];
            this.v_lineas;
            this.v_lineas_pedido = [];
            this.v_orden_exp = new Array();
            this.v_cant_linea;
            this.dataAux;
            this.v_pedidoActual_cant;
            this.bulto = [];
            this.v_bultos = [];
            this.v_control_lote_ubic;
            this.v_posicion_pedido;
            this.v_numBulto = 0;
            this.v_albaranSeleccionado = null;
            this.dialogOpening = false;
            this.DejarPendiente = false;

            //this.btnNuevo = document.getElementById('btnNuevoPedido');
            this.btnNuevo = boton('btnNuevoPedido')
                .clic(this.Clear.bind(this))
                .crea();

            //this.btnContinuarExped = document.getElementById('ContinuarExped');
            this.btnContinuarExped = boton('ContinuarExped')
                .clic(this.GenerarExpedicion.bind(this))
                .crea();

            //this.btnImprimirExped = document.getElementById('ImprimirExped');
            this.btnImprimirExped = boton('ImprimirExped')
                .clic(this.ImprimirExpedicion.bind(this))
                .crea();

            //this.btnCampRefer = document.getElementById('campRefer');
            this.btnCampRefer = boton('campRefer')
                .clic(this.ClearCode.bind(this))
                .crea();

            //this.btnEnvioAceptar = document.getElementById('envioAceptar');
            this.btnEnvioAceptar = boton('envioAceptar')
                .clic(this.EnvioAceptar.bind(this))
                .crea();

            //this.btnConfirm = document.getElementById('confirmar');
            this.btnConfirm = boton('confirmar')
                .clic(this.Confirmar.bind(this))
                .crea();

            //this.btnPdte = document.getElementById('btnPdte');
            this.btnPdte = boton('btnPdte')
                .clic(this.Pendiente.bind(this))
                .crea();

            this.tBody = $($('#tablaPedidos').DataTable().table().container());

            //this.txtPedido = $('#txtPedido');
            this.txtPedido = campo('txtPedido')
                .cambio(this.ObtenerPedido.bind(this))
                .crea();

            this.txtCliente = $('#txtCliente');
            this.txtNomCliente = $('#txtNomCliente');

            //this.campRefer = $('#campRefer');
            this.campRefer = campo('campRefer')
                .cambio(this.SearchByRef.bind(this))
                .crea();

            //this.refCant = $('#campCant');
            this.refCant = campo('campCant')
                .cambio(this.CantSinLotUb.bind(this))
                .crea();

            this.selectType = document.getElementById('selectType');

            //this.inpCodTransportista = document.getElementById('codTransportistaInput');
            this.inpCodTransportista = campo('codTransportistaInput')
                .cambio(this.CambioTransportista.bind(this))
                .crea();

            //this.inpCodVehiculo = document.getElementById('codVehiculoInput');
            this.inpCodVehiculo = campo('codVehiculoInput')
                .cambio(this.CambioVehiculo.bind(this))
                .crea();

            //this.btnTransporterSearch = document.getElementById('transporterSearch');
            this.btnTransporterSearch = boton('transporterSearch')
                .clic(this.SearchTransporter.bind(this))
                .crea();

            //this.btnVehicleSearch = document.getElementById('vehicleSearch');
            this.btnVehicleSearch = boton('vehicleSearch')
                .clic(this.SearchVehicle)
                .crea();

            //this.btnEnvioAceptar = document.getElementById('envioAceptar');
            this.bultosInput = document.getElementById('bultosInput');
            this.pesoInput = document.getElementById('pesoInput');
            this.etiquetasInput = document.getElementById('etiquetasInput');
            this.AlbValContainer = document.getElementById('AlbValContainer');
            this.chkAlbaranVal = document.getElementById('chkAlbaranVal');
        }
        Expedicion.prototype.initialize = function () {

            this./*exp*/v_tabla = $('#tablaPedidos').DataTable();

            this./*exp*/v_lineas = this./*exp*/v_tabla.rows().data();
        };

        Expedicion.prototype.NuevoPedido = function () {
            this./*exp*/detallesProd = [];
            this./*exp*/v_lineas_pedido = [];
            this./*exp*/bulto = [];
            this./*exp*/v_bultos = [];
            this./*exp*/v_orden_exp = new Array();
            this./*exp*/v_numBulto = 0;
            this./*exp*/dialogOpening = false;
            this./*exp*/v_albaranSeleccionado = null;
            this./*exp*/v_tabla.clear().draw();
            $(this./*exp*/campRefer).val("");
            this./*exp*/txtCliente.val("");
            this./*exp*/txtNomCliente.val("");
        };

        Expedicion.prototype.Clear = async function () {
            //$(this./*exp*/txtPedido).val("").focus().select();
            this.txtPedido.valor(null);
            this./*exp*/NuevoPedido();
            this.txtPedido.foco();

            await modal('dialogo-lotes-ubicaciones')
                .construye(p_modal => {
                    let v_dialogo = new DialogoLotesUbicaciones(p_modal, 'MER0501', 'Mermelada', 77, [
                        { GAUBIC_COD: "U1", LOTE: "L1", C_UNI1: 666 },
                        { GAUBIC_COD: "U2", LOTE: "L2", C_UNI1: 747 },
                        { GAUBIC_COD: "U3", LOTE: "L3", C_UNI1: 999 },
                    ]);
                    v_dialogo.actualizaVista();
                    return v_dialogo;
                })
                .abre();

            debugger;
        };

        Expedicion.prototype.ObtenerPedido = function (e) {
            // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
            //if (e.which === 13) {
            {
                this./*exp*/NuevoPedido();
                //$('#txtPedido').val($('#txtPedido').val().toUpperCase());
                this.txtPedido.valor(this.txtPedido.valor().toUpperCase());
                var url = "expedicion/pedido";
                var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), lecturaPedido: this.txtPedido.valor() };
                var method = "GET";
                var success = (function (response) {
                    $(this./*exp*/AlbValContainer).hide();
                    var Ok = (async function () {
                        this./*exp*/MostrarAlbaranValorado = response.Objeto.MostrarAlbaranValorado;
                        $(this./*exp*/chkAlbaranVal).prop('checked', response.Objeto.AlbaranValorado);
                        this./*exp*/txtCliente.val(response.Objeto.GGCLIPR_COD);
                        this./*exp*/txtNomCliente.val(response.Objeto.GGCLIPR_NOMBRE);

                        this./*exp*/dataAux = response.Objeto;
                        n_albaranes = this./*exp*/dataAux.Albaranes.length;
                        if (this./*exp*/dataAux.OBSER && this./*exp*/dataAux.OBSER.trim() !== "") {
                            //lanzarMensaje(response.Ok, this./*exp*/dataAux.OBSER, this./*exp*/ObservFunc.bind(this));
                            let v_respuesta = await mensaje(this.dataAux.OBSER).muestra();
                            if (typeof v_respuesta !== 'undefined')
                                //this.ObservFunc();
                                this.LanzarEnvios();
                        } else {
                            this./*exp*/LanzarEnvios();
                        }
                    }).bind(this);
                    var error = function () {
                        //$('#txtPedido').focus().select();
                        this.txtPedido.foco();
                    };
                    handleResponse(response, Ok, error);
                }).bind(this);

                apiGeneral(url, method, datos, success);

                $(this).blur();
                e.preventDefault();
            }
        };

        Expedicion.prototype.ArticleData = function () {
            var selectedRow = this./*exp*/v_tabla.row('.selected')[0];
            $('#descArticulo').val(this./*exp*/v_tabla.rows(selectedRow).data()[0].GAART_DESCRIP);
            $('#ref #campRefer').val(this./*exp*/v_tabla.rows(selectedRow).data()[0].GAART_COD);

            var LotUbic = $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_LOTES_SN + $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_UBIC_SN;
            var N_lin = $('#tablaPedidos').DataTable().row(selectedRow).data().N_LIN;
            $($('#tablaPedidos').DataTable().row(selectedRow).node()).addClass(LotUbic).prop("id", N_lin);
            row = $(this./*exp*/v_tabla.row(selectedRow).node());
            this./*exp*/ControlLotUb(row);
        };

        Expedicion.prototype.SelectArticle = function () {
            this./*exp*/ArticleData();
            if (this./*exp*/v_lineas.length > 0) {
                if (!this./*exp*/dialogOpening) {
                    var tableRow = $(this./*exp*/v_tabla.row('.selected').node());

                    //Si no tiene control de lotes ni ubicaciones seguira por la función
                    this./*exp*/ControlLotUb(tableRow);

                    //si no, seguira adelante
                    if (!tableRow.hasClass('NN')) {
                        this./*exp*/dialogOpening = true;
                        this./*exp*/v_posicion_pedido = eval($('#tablaPedidos').DataTable().row(tableRow).data().N_LIN);
                        for (i = 0; i < this./*exp*/v_lineas.length; i++) {
                            if (!this./*exp*/v_lineas_pedido[i]) {
                                this./*exp*/v_lineas_pedido.push({ 'C_UNI1': 0, 'N_LIN': eval(this./*exp*/v_lineas[i].N_LIN) });
                            }
                        }
                        this./*exp*/v_lineas = this./*exp*/v_tabla.rows().data();
                        this./*exp*/v_pedidoActual_cant = 0;
                        this./*exp*/detallesProd = [];
                        this./*exp*/v_cant_linea = this./*exp*/v_tabla.rows(tableRow).data()[0].C_PDTE;
                        this./*exp*/v_control_lote_ubic = 'SS';
                        var v_dialog = "#dialogLoV";
                        var v_nombre_tabla = 'tablaUbicaciones';
                        var v_column = [
                            generateColumn('GAUBIC_COD', Resources.table_head_location),
                            generateColumn('LOTE', Resources.table_head_batch),
                            generateColumn('C_UNI1', Resources.table_head_available, true, true)
                        ];
                        var columnDefs = [
                            { "width": "6em", "targets": 0 },
                            { "width": "4em", "targets": 2 }
                        ];

                        var id = this./*exp*/BuscarLineaPedido(tableRow.prop('id'));

                        if (!tableRow.hasClass('SS')) {
                            var col = tableRow.hasClass('NS') ? true : false;
                            if (col) {
                                this./*exp*/v_control_lote_ubic = 'NS';
                                v_column = [
                                    generateColumn('GAUBIC_COD', Resources.table_head_location),
                                    generateColumn('LOTE', Resources.table_head_batch, false),
                                    generateColumn('C_UNI1', Resources.table_head_available, true, true)
                                ];
                                columnDefs = [
                                    { "width": "4em", "targets": 2 }
                                ];
                            } else {
                                this./*exp*/v_control_lote_ubic = 'SN';
                                v_column = [
                                    generateColumn('GAUBIC_COD', Resources.table_head_location, false),
                                    generateColumn('LOTE', Resources.table_head_batch),
                                    generateColumn('C_UNI1', Resources.table_head_available, true, true)
                                ];
                                columnDefs = [
                                    { "width": "4em", "targets": 2 }
                                ];
                            }
                        }

                        //var url = Router.action('Dialog', 'Dialog');
                        var url = "Dialog/Dialog";

                        var inputs =
                            [
                                generateSingleInput(4, Resources.label_ubicacion, 'txtUbic', '', 'campUbicacion', 'focusable'),
                                generateSingleInput(5, Resources.label_lote, 'txtLote', '', 'campLote', 'focusable'),
                                generateSingleInput(3, Resources.label_quantity_shrt, 'txtCant', '', 'campCant', 'focusable text-right', true)
                            ];
                        var upperInputs =
                            [
                                generateSingleInput(4, Resources.label_ref, 'txtRef', this./*exp*/v_tabla.rows(tableRow).data()[0].GAART_COD, 'campRef', null, null, null, true),
                                generateSingleInput(5, Resources.label_description, 'txtDescrip', this./*exp*/v_tabla.rows(tableRow).data()[0].GAART_DESCRIP, 'campDescrip', null, null, null, true),
                                generateSingleInput(3, Resources.label_pending, 'txtPdte', '', 'campPdte', 'text-right', null, null, true)
                            ];
                        var buttons = [{ id: 'aceptar', value: Resources.button_accept }];

                        generarDialogAuto(url, v_dialog, v_nombre_tabla, null, this./*exp*/v_dataClon.Lineas[id].Existencias, v_column, buttons, inputs, upperInputs, this./*exp*/SelectUbicacion.bind(this), Resources.title_location, ['dialogPedidos2'], null, null, Resources.table_zeroRecordsMessage_no_stock, null, false, columnDefs);
                    }
                }
            } else {
                $('#confirmar').prop('disabled', true);
            }
        };

        Expedicion.prototype.SearchByRef = function (e) {
            // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
            //if (e.which === 13) {
            {
                if (!this./*exp*/BuscarProducto.apply(this) && $('#tablaPedidos').DataTable().rows().data().length > 0) {
                    var url = "expedicion/Articulos";
                    var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), codigoBarras: $('#campRefer').val() };
                    var method = "GET";
                    var success = (function (response) {
                        var Ok = (function () {
                            var v_articulos = response.Objeto;
                            obtenerCodBarras($('#campRefer'));

                            //En caso de que haya más de un producto con el mismo código en la DB
                            if (v_articulos.length > 1) {
                                v_articulos = this./*exp*/ProductosMultiples(v_articulos);
                            }
                            if (v_articulos.length === 1) {
                                $('#campRefer').val(v_articulos[0].GAART_COD);
                                if (!this./*exp*/BuscarProducto()) {
                                    lanzarMensaje(false, Resources.error_article_not_found);
                                }
                            } else if (v_articulos.length === 0) {
                                lanzarMensaje(response.Ok, Resources.error_ref_incorrect);
                            }
                        }).bind(this);
                        var error = function () {
                            $('#campRefer').focus().select();
                        };
                        handleResponse(response, Ok, error);
                    }).bind(this);
                    apiGeneral(url, method, datos, success);
                } else if ($('#tablaPedidos').DataTable().rows().data().length === 0) {
                    lanzarMensaje(false, Resources.error_select_order, (function () { this.txtPedido.foco(); }).bind(this));
                } else if ($('#tablaPedidos').DataTable().rows().data().length > 1) {
                    var tableData = $('#tablaPedidos').DataTable().rows().data();
                    var data = [];
                    tableData.each(function (d) {
                        if (d.GAART_COD === $('#campRefer').val()) {
                            data.push(d);
                        }
                    });
                    this./*exp*/ProductosMultiples(data);
                } else {
                    console.log("Error en productos multiples");
                }
                $(e.target).blur();
                e.preventDefault();
            }
        };

        Expedicion.prototype.Confirmar = function () {
            this./*exp*/DejarPendiente = false;
            this./*exp*/RealizarConfirmacion();
        };

        Expedicion.prototype.RealizarConfirmacion = function () {
            if (!this./*exp*/dialogOpening && this./*exp*/data) {
                this./*exp*/RecogerDatos();
                if ($('#campCant').val().trim() === "") {
                    var vacio = true;
                    if (this./*exp*/v_orden_exp.length !== 0) {
                        for (i = 0; i < this./*exp*/v_orden_exp.LINEAS.length; i++) {
                            if (this./*exp*/v_orden_exp.LINEAS[i].C_UNI1 !== 0) {
                                vacio = false;
                            }
                        }
                    }
                    if (!vacio) {
                        this./*exp*/TransformExpedicion();

                        var url = "expedicion/resumenbultos";
                        var datos = this./*exp*/v_orden_exp;
                        var method = "PUT";
                        var success = (function (response) {
                            var Ok = (function () {
                                showDialog("#dialogEnviosEtiquetas");
                                $('.datosEnvio').hide();
                                $('#bultosInput').val(response.Objeto.N_BULTOS);
                                $('#pesoInput').val(response.Objeto.PESO);
                                $('#etiquetasInput').val(response.Objeto.N_ETIQUETAS);
                                $('.datosEtiquetas').show();
                                this./*exp*/MostrarAlbaranValorado ? $(this./*exp*/AlbValContainer).show() : $(this./*exp*/AlbValContainer).hide();
                                $("#codTransportistaInput").focus().select();
                                this./*exp*/Opciones = response.Objeto.Opciones;
                                this./*exp*/v_orden_exp.N_COPIAS = response.Objeto.N_COPIAS;
                                this./*exp*/GestionaCopias();

                                $(this./*exp*/selectType).empty();
                                $.each(this./*exp*/Opciones, (function (i, Obj) {
                                    $(this./*exp*/selectType).append($('<option>', {
                                        value: Obj,
                                        text: Obj
                                    }));
                                }).bind(this));
                                $(this./*exp*/selectType).val(response.Objeto.OpcionPredeterminada);
                            }).bind(this);
                            handleResponse(response, Ok);
                        }).bind(this);

                        apiGeneral(url, method, datos, success);
                    } else {
                        lanzarMensaje(false, Resources.error_prep_pedido);
                    }
                }
            }
        };

        Expedicion.prototype.ContinuarExped = function () {
            this./*exp*/DatosEnvio();
            this./*exp*/GenerarExpedicion();
        };
        Expedicion.prototype.ContinuarImpr = function () {
            this./*exp*/DatosEnvio();
            this./*exp*/GenerarExpedicion();
        };
        Expedicion.prototype.ClearCode = function () {
            this./*exp*/v_code = "";
        };

        Expedicion.prototype.EnvioConfirmar = function () {
            this./*exp*/expedir();
            $('#dialogEnviosEtiquetas #codTransportistaInput').prop("value", $('#codTransporte').val());
            $('#dialogEnviosEtiquetas #nombreTransportistaInput').prop("value", $('#nombreTransporte').val());
            $('#dialogEnviosEtiquetas #codVehiculoInput').prop("value", $('#codVehiculo').val());
            $('#dialogEnviosEtiquetas #descrVehiculoInput').prop("value", $('#descrVehiculo').val());
            $('.transp').addClass('half');
        };

        Expedicion.prototype.BuscarLineaPedido = function (id) {
            for (i = 0; i < this./*exp*/data.Lineas.length; i++) {
                if (TryParseInt(this./*exp*/data.Lineas[i].N_LIN, -1) === TryParseInt(id, -2)) {
                    return i;
                }
            }
        };

        Expedicion.prototype.CantSinLotUb = function () {
            var selexpf = this;
            this./*exp*/v_tabla = $('#tablaPedidos').DataTable();
            this./*exp*/v_posicion_pedido = eval($('#tablaPedidos').DataTable().row('.selected').data().N_LIN);
            var v_cantVal = TryParseInt($('#ref #campCant').val().trim(), 0);

            if (v_cantVal !== 0) {
                dialogOpening = true;
                for (i = 0; i < this./*exp*/v_lineas.length; i++) {
                    if (!this./*exp*/v_lineas_pedido[i]) {
                        this./*exp*/v_lineas_pedido.push({ 'C_UNI1': 0, 'N_LIN': eval(this./*exp*/v_lineas[i].N_LIN) });
                    }
                }
                this./*exp*/detallesProd = [];
                var posicion = this./*exp*/BuscarLineaPedido(this./*exp*/v_tabla.row('.selected').data().N_LIN);
                var existencias = 0;
                var v_existencias = this./*exp*/data.Lineas[posicion].Existencias;
                for (i = 0; i < v_existencias.length; i++) {
                    existencias = existencias + v_existencias[i].C_UNI1;
                }
                var v_cantidad = eval(v_cantVal);
                this./*exp*/v_pedidoActual_cant = 0;
                this./*exp*/ModCantidades(existencias, v_cantidad, eval(this./*exp*/v_tabla.row('.selected').data().C_PDTE));
                this./*exp*/LanzarVentanaBultos("#dialogLoV");
                $('#ref #campCant').val("");
            }
        };

        Expedicion.prototype.ControlLotUb = function (JQInput) {
            if (JQInput.hasClass('NN')) {
                $('#txtRefer').removeClass('col-xs-10');
                $('#txtRefer').addClass('col-xs-5');
                $('.sinLote').show();
                // RBM $('#ref #campCant').focus();
                document.tabulado.siguiente($('#ref #campCant'));
                if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
                    for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
                        var ia = TryParseInt(v_code.obtenerIdentificadores[i].ia);
                        if (ia === 37) {
                            $('#ref #campCant').val(v_code.obtenerIdentificadores[i].valor);
                        }
                    }
                }
                resizePedidos();
            } else {
                $('#txtRefer').addClass('col-xs-10');
                $('#txtRefer').removeClass('col-xs-5');
                $('.sinLote').hide();
            }
        };

        Expedicion.prototype.BuscarProducto = function () {
            for (i = 0; i < this./*exp*/v_tabla.rows().data().length; i++) {
                if (this./*exp*/v_tabla.row(i).data().GAART_COD === $('#campRefer').val().trim()) {
                    this./*exp*/v_tabla.row('.selected').nodes().to$().removeClass('selected');
                    this./*exp*/v_tabla.row(i).nodes().to$().addClass('selected');
                    $('#tablaPedidos .selected').click();
                    return true;
                }
            }
            return false;
        };

        Expedicion.prototype.SeleccionProdRepetido = function () {
            $('#dialogLoV #accept').on('click', (function () {
                var searchArray = [
                    { KEY: "GAART_COD", VALUE: $('#LoVTable').DataTable().row('.selected').data().GAART_COD },
                    { KEY: "GAART_DESCRIP", VALUE: $('#LoVTable').DataTable().row('.selected').data().GAART_DESCRIP }
                ];
                seleccionFila("#tablaPedidos", searchArray);
                $('#campRefer').val($('#LoVTable').DataTable().row('.selected').data().GAART_COD);
                closeModal('#dialogLoV');
                //$('#campRefer').trigger(jQuery.Event('keypress', { which: 13 }));
                this./*exp*/SelectArticle();
            }).bind(this));
        };

        Expedicion.prototype.ProductosMultiples = function (v_articulos) {
            //En caso de que haya más de un producto con el mismo código en el pedido
            if (v_articulos.length > 1) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var v_columns = [generateColumn('GAART_COD', Resources.table_head_code), generateColumn('GAART_DESCRIP', Resources.table_head_description)];
                var columnDefs = [
                    { width: '6em', targets: 0 }
                ];
                var v_buttons = [generateSingleButton('accept', Resources.button_accept)];
                generarDialogAuto(url, '#dialogLoV', 'LoVTable', null, v_articulos, v_columns, v_buttons, null, null, this./*exp*/SeleccionProdRepetido, Resources.title_multiple_products, null, Resources.message_multiple_products, null, null, null, null, columnDefs);
            }
            return v_articulos;
        };

        Expedicion.prototype.ObservFunc = function () {
            this./*exp*/LanzarEnvios();
        };

        Expedicion.prototype.LanzarEnvios = function () {
            $('#codTransportistaInput').val(this./*exp*/dataAux.GGMENVIO_COD);
            $('#nombreTransportistaInput').val(this./*exp*/dataAux.GGMENVIO_DESCRIP);
            $('#codVehiculoInput').val(this./*exp*/dataAux.GGVEHICULO_COD);
            $('#descrVehiculoInput').val(this./*exp*/dataAux.GGVEHICULO_DESCRIP);
            if (this./*exp*/dataAux.DatosEnvioInicial) {
                showDialog("#dialogEnviosEtiquetas");
                $('.datosEnvio').show();
                $('#envioContent').addClass("blank-space");
                $('.datosEtiquetas').hide();
                // RBM $("#codTransportistaInput").focus().select();
                document.tabulado.siguiente($('#codTransportistaInput'));

            } else {
                this./*exp*/DatosEnvio();
                this.LanzarAlbaranes();
            }
        };

        Expedicion.prototype.Pendiente = function () {
            this./*exp*/DejarPendiente = true;
            this./*exp*/RealizarConfirmacion();
        };

        Expedicion.prototype.SelectAlbaran = function () {
            // Para cambios de albarán en medio de un pedido en proceso
            $('#tablaAlbaranes').on('dblclick', (function () {
                this./*exp*/SeleccionAlbaran();
                closeModal('#dialogLoV');
            }).bind(this));

            $('#seleccionarAlbaran').on("click", (function () {
                this./*exp*/SeleccionAlbaran();
                closeModal('#dialogLoV');
            }).bind(this));

            $('#nuevoAlbaran').on("click", (function () {
                this./*exp*/DatosAlbaran("", "", "");
                closeModal('#dialogLoV');
            }).bind(this));
        };

        Expedicion.prototype.SelectAlbaranPintarPed = function () {
            // Selección de albarán que añade los datos del pedido a la tabla
            $('#tablaAlbaranes').on('dblclick', (function () {
                this./*exp*/SeleccionAlbaran();
                this./*exp*/PintarTablaPedidos();
                closeModal('#dialogLoV');
            }).bind(this));

            $('#seleccionarAlbaran').on("click", (function () {
                this./*exp*/SeleccionAlbaran();
                this./*exp*/PintarTablaPedidos();
                closeModal('#dialogLoV');
            }).bind(this));

            $('#nuevoAlbaran').on("click", (function () {
                this./*exp*/DatosAlbaran("", "", "");
                this./*exp*/PintarTablaPedidos();
                closeModal('#dialogLoV');
            }).bind(this));
        };

        Expedicion.prototype.DatosAlbaran = function (tipoAlbaran, numAlbaran, fechaAlbaran) {
            // Recoge los datos del albaran y actualiza los datos en el menú
            $('#tipoAlbaran').val(tipoAlbaran);
            $('#numAlbaran').val(numAlbaran);
            $('#confirmar').prop('disabled', false);
            $('#dialogAlbaranes').modal('hide');
            var v_fecha = fechaAlbaran === "" ? new Date() : new Date(fechaAlbaran);
            updateDatePicker(v_fecha);
            this./*exp*/CambioAlbaran();
        };

        Expedicion.prototype.SeleccionAlbaran = function () {
            if ($('#tablaAlbaranes').DataTable().rows()[0].length > 0) {
                this./*exp*/v_albaranSeleccionado = $('#tablaAlbaranes').DataTable().row('.selected').data();
                var v_albaran_seleccionado = $('#tablaAlbaranes').DataTable().rows('.selected').data()[0];
                var v_tipoAlbaran = v_albaran_seleccionado.GGALBTIP_COD;
                var v_numAlbaran = v_albaran_seleccionado.N_ALBARAN;
                var v_fechaAlbaran = v_albaran_seleccionado.F_ALBARAN_HID;
                this./*exp*/DatosAlbaran(v_tipoAlbaran, v_numAlbaran, v_fechaAlbaran);
                this./*exp*/CambioAlbaran();
            }
        };

        Expedicion.prototype.PintarTablaPedidos = function () {
            this./*exp*/data = this./*exp*/dataAux;

            // Clon de data para que los datos no sean modificados 
            // en el caso de que se cancele la operación
            this./*exp*/v_dataClon = JSON.parse(JSON.stringify(this./*exp*/data));

            this./*exp*/initialize();
            this./*exp*/GenerarMenu();

            var v_table = $('#tablaPedidos').DataTable();
            v_table.clear().draw();
            if (v_table.rows.length === 0) {
                v_table.rows.add(this./*exp*/data.Lineas).draw();
                this./*exp*/v_lineas = v_table.rows().data();
                selectRow('#tablaPedidos');
            }
            $('#menuObservaciones').show();

            $('#txtRefer').addClass('col-xs-10');
            $('#txtRefer').removeClass('col-xs-5');
            $('.sinLote').hide();

            $('#campRefer').val("").get(0).focus();
            // Si el pedido tiene alguna observación
            if (this./*exp*/data.OBSER) {
                $('#menuObservaciones input').val(Resources.menu_show);
            } else {
                $('#menuObservaciones input').val(Resources.menu_no_observations);
            }

            // Si el albarán no es nuevo
            if (typeof v_albaranSeleccionado !== 'undefined') {
                var refAlb = v_albaranSeleccionado.SU_REF_ALB;
                $('#menuRefAlbaran input').val(refAlb);
                $('#codRefAlbaran').val(refAlb);
            }
            closeModal("#dialogAlbaranes");
        };


        Expedicion.prototype.CambioAlbaran = function () {
            // Actualiza el menú desplegable con el albarán seleccionado
            if ($("#tipoAlbaran").val() !== "" && $("#numAlbaran").val() !== "") {
                v_albaran = $("#tipoAlbaran").val() + "-" + $("#numAlbaran").val();
            } else {
                v_albaran = Resources.menu_new;
            }
            $('#menuAlbaran div input').val(v_albaran);
        };

        Expedicion.prototype.GestionaCopias = function () {
            if (this./*exp*/DejarPendiente) {
                $('#CopiasInput').val(this./*exp*/v_orden_exp.N_COPIAS);
                $('.copiasField').show();
            } else {
                $('.copiasField').hide();
            }
        };

        Expedicion.prototype.GenerarMenu = function () {
            this./*exp*/CambioAlbaran();

            this./*exp*/MenuInit();
            menuElement(Resources.menu_delivery_note_date, 'fecha', '#', dateToString(getDateAlb(this./*exp*/v_albaranSeleccionado)), 'buscador', 'menuDate');
            menuElement(Resources.menu_delivery_note_change, 'observaciones', '#', v_albaran, 'buscador', 'menuAlbaran');
            menuElement('Ref. Albarán', 'observaciones', '#', 'Sin ref.', '', 'menuRefAlbaran');
            menuElement(Resources.menu_observations, 'observaciones', '#', "Mostrar", '', 'menuObservaciones');

            menuDatePicker();

            $("#tipoAlbaran").bind("change paste keyup", (function () {
                this./*exp*/CambioAlbaran();
            }).bind(this));
            $("#numAlbaran").bind("change paste keyup", (function () {
                this./*exp*/CambioAlbaran();
            }).bind(this));

            $('#menuAlbaran').on('click', (function () {
                if (typeof this./*exp*/data !== 'undefined') {
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";
                    var v_columns = [
                        generateColumn('GGALBTIP_COD', Resources.table_head_type),
                        generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
                        generateColumn('F_ALBARAN', Resources.table_head_date),
                        generateColumn('GGESTADO_COD', Resources.table_head_state),
                        generateColumn('F_ALBARAN_HID', '', false)
                    ];

                    var columnDefs = [
                        { "width": "4em", "targets": 0 },
                        { "width": "4em", "targets": 1 },
                        { "width": "2em", "targets": 3 }
                    ];
                    var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left')];
                    var v_albaranes = this./*exp*/data.Albaranes.map(function (albaran) {
                        return {
                            GGALBTIP_COD: albaran.GGALBTIP_COD,
                            N_ALBARAN: albaran.N_ALBARAN,
                            //Fecha formateada para su visualización
                            F_ALBARAN: moment(albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                            GGESTADO_COD: albaran.GGESTADO_COD,
                            //Fecha sin formatear (Oculto)
                            F_ALBARAN_HID: albaran.F_ALBARAN,
                            SU_REF_ALB: albaran.SU_REF_ALB
                        };
                    });
                    generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, null, this./*exp*/SelectAlbaran, Resources.title_delivery_note_selection, null, null, null, null, null, null, columnDefs);
                }
            }).bind(this));

            $('#menuObservaciones').on('click', (function () {
                if (this./*exp*/data) {
                    if (this./*exp*/data.OBSER && this./*exp*/data.OBSER.trim() !== "")
                        lanzarMensaje(true, this./*exp*/data.OBSER);
                    else
                        lanzarMensaje(true, Resources.message_no_observations);
                } else {
                    lanzarMensaje(false, Resources.error_insert_order);
                }
            }).bind(this));
        };


        var exp;



        function restartData() {
            this./*exp*/v_dataClon = JSON.parse(JSON.stringify(this./*exp*/data));
            $("#campRefer").focus().select();
        }

        Expedicion.prototype.LanzarAlbaranes = function () {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var v_columns = [
                generateColumn('GGALBTIP_COD', Resources.table_head_type),
                generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
                generateColumn('F_ALBARAN', Resources.table_head_date),
                generateColumn('GGESTADO_COD', Resources.table_head_state),
                generateColumn('F_ALBARAN_HID', '', false)
            ];

            var inputs = [
                generateSingleInput('12', 'Buscar albarán', 'txtBuscaAlbaran', '', '', 'focusable code')
            ];
            var columnDefs = [
                { "width": "4em", "targets": 0 },
                { "width": "4em", "targets": 1 },
                { "className": "dt-center", "targets": 2 },
                { "width": "2em", "targets": 3 }
            ];
            var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left', 'gray')];
            if (this./*exp*/dataAux.Albaranes.length !== 0) {
                var v_albaranes = this./*exp*/dataAux.Albaranes.map(function (albaran) {
                    return {
                        GGALBTIP_COD: albaran.GGALBTIP_COD,
                        N_ALBARAN: albaran.N_ALBARAN,
                        //Fecha formateada para su visualización
                        F_ALBARAN: moment(albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                        GGESTADO_COD: albaran.GGESTADO_COD,
                        //Fecha sin formatear (Oculto)
                        F_ALBARAN_HID: albaran.F_ALBARAN
                    };
                });
                var fnAlbaran = (function () {
                    $('#txtBuscaAlbaran').focus();
                    $('#txtBuscaAlbaran').keypress((function (e) {
                        if (e.which === 13) {
                            var url = "/Expedicion/NumeroAlbaran";
                            var method = "GET";
                            var data = {
                                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                                emp_cod: sessionStorage.getItem("EMPR_COD"),
                                lectura_albaran: $('#txtBuscaAlbaran').val()
                            };
                            var success = function (response) {
                                var Ok = function () {
                                    var GGALBTIP_COD = response.Objeto.GGALBTIP_COD;
                                    var N_ALBARAN = response.Objeto.N_ALBARAN;

                                    var searchArray = [
                                        { KEY: "GGALBTIP_COD", VALUE: GGALBTIP_COD },
                                        { KEY: "N_ALBARAN", VALUE: N_ALBARAN }
                                    ];
                                    var found = seleccionFila("#tablaAlbaranes", searchArray);
                                    if (!found) lanzarMensaje(false, "No se ha encontrado el albarán introducido", function () { $('#txtBuscaAlbaran').focus().select(); });
                                    else $('#seleccionarAlbaran').click();
                                };
                                var error = function () {
                                    lanzarMensaje(false, "No se ha encontrado el albarán introducido", function () { $('#txtBuscaAlbaran').focus().select(); });
                                };
                                handleResponse(response, Ok, error);
                            };
                            apiGeneral(url, method, data, success);
                        }
                    }).bind(this));
                    this./*exp*/SelectAlbaranPintarPed();
                }).bind(this);
                generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, inputs, fnAlbaran, Resources.title_delivery_note_selection, null, null, null, null, null, false, columnDefs);
            } else {
                this./*exp*/DatosAlbaran("", "", "");
                this./*exp*/PintarTablaPedidos();
            }
        }

        return Expedicion;
    });