﻿define('expedicion-ubicaciones', ['expedicion-expedicion', 'componentes'],
    function (Expedicion, { boton, campo }) {

        Expedicion.prototype.SelectUbicacion = function () {
            var v_table = $('#tablaUbicaciones').DataTable();

            //var txtCant = $('#txtCant');

            let txtCant = campo('txtCant')
                .cambio((function (e) {
                    if (txtCant.valor()) this./*exp*/Ubicacion();
                }).bind(this))
                .crea();

            var txtLote = $('#txtLote');
            var txtUbic = $('#txtUbic');
            var btnAccept = document.getElementById('aceptar');

            $('#tablaUbicaciones tbody').on('click', ubicationData);

            // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
            //txtUbic.keypress(function (e) {
            //    if (e.which === 13) {
            txtUbic.on("change", (function (e) {
                {
                    if ($(this).val() !== "") {
                        getUbic();
                        setTimeout(function () {
                            focusCant();
                            focusLote();
                        });
                        e.preventDefault();
                    }
                }
            }).bind(this));

            // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
            //txtLote.keypress(function (e) {
            //    if (e.which === 13) {
            txtLote.on("change", (function (e) {
                {
                    if ($(this).val() !== "") {
                        getLote();
                        focusCant();
                        e.preventDefault();
                    }
                }
            }).bind(this));

            // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
            //txtCant.keypress(function (e) {
            //    if (e.which === 13) {
            //txtCant.on("change", (function (e) {
            //    {
            //        if ($(this).val()) this./*exp*/Ubicacion();
            //    }
            //}).bind(this));

            var ubicationData = (function () {
                if (v_table.rows()[0].length > 0) {
                    var selectedRow = v_table.row('.selected')[0];
                    $('#txtUbic').val(v_table.rows(selectedRow).data()[0].GAUBIC_COD);
                    $('#txtLote').val(v_table.rows(selectedRow).data()[0].LOTE);

                    var pendiente = $("#txtPdte").val();
                    var cantidadEnUbic = v_table.row(selectedRow).data().C_UNI1;
                    //$('#txtCant').val(setOptimumQty(pendiente, cantidadEnUbic));
                    txtCant.valor(setOptimumQty(pendiente, cantidadEnUbic));
                }
            }).bind(this);

            var getUbic = (function () {
                var arrayBusqueda = [];
                arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() });
                var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
                if (this./*exp*/v_control_lote_ubic === 'NS') {
                    if (existeFila) $('#tablaUbicaciones .selected').click();
                } else {
                    setUbicLote();
                }
            }).bind(this)

            var getLote = (function () {
                var arrayBusqueda = [];
                if (this./*exp*/v_control_lote_ubic === 'SN') {
                    arrayBusqueda.push({ KEY: 'LOTE', VALUE: $('#txtLote').val() });
                } else {
                    arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() }, { KEY: 'LOTE', VALUE: $('#txtLote').val() });
                }
                var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
                if (existeFila) $('#tablaUbicaciones .selected').click();
            }).bind(this);

            var resetFocus = (function () {
                if (this./*exp*/v_control_lote_ubic === 'SN') {
                    $('#txtLote').focus().select();
                } else {
                    $('#txtUbic').focus().select();
                }
            }).bind(this);

            //txtLote.blur(function () {
            //    if (v_control_lote_ubic == 'SN') {
            //        seleccionFila("#tablaUbicaciones", "", $(this).val());
            //    } else {
            //        seleccionFila("#tablaUbicaciones", $('#txtUbic').val(), $(this).val());
            //    }
            //    clickOnSelected();
            //});
            function focusUbic() {
                txtUbic.focus().select();
            }

            function focusLote() {
                txtLote.focus().select();
            }

            function focusCant() {
                txtCant.foco();
            }

            this./*exp*/dialogOpening = false;
            cambioTamanioPed();

            if (this./*exp*/v_control_lote_ubic === 'SN') {
                $('#campUbicacion').hide();
                $('#campLote').removeClass('col-xs-5');
                $('#campLote').addClass('col-xs-7');
                $('#campCant').removeClass('col-xs-3');
                $('#campCant').addClass('col-xs-5');
            } else if (this./*exp*/v_control_lote_ubic === 'NS') {
                $('#campLote').hide();
                $('#campUbicacion').removeClass('col-xs-4');
                $('#campUbicacion').addClass('col-xs-7');
                $('#campCant').removeClass('col-xs-3');
                $('#campCant').addClass('col-xs-5');
            }
            $("#txtPdte").val(this./*exp*/v_cant_linea);


            $('#tablaUbicaciones').on("click", "tr", function () {
                var table = $('#tablaUbicaciones').DataTable();
                if (table.rows()[0].length > 0) {
                    setUbicLote();
                    txtCant.foco();
                } else {
                    focusLote();
                    focusUbic();
                }
            });

            var confirmarUbicaciones = (function () {
                // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
                //var e = jQuery.Event("keypress");
                //e.which = e.keyCode = 13;
                var e = jQuery.Event("change");
                //$(txtCant).trigger(e);
                if (txtCant.valor()) this./*exp*/Ubicacion();

                if (this./*exp*/v_pedidoActual_cant !== 0) {
                    if (!this./*exp*/data.BultosPorLinea) {
                        this./*exp*/RecogerDetalles();
                        this./*exp*/dialogOpening = false;
                        closeModal("#dialogPedidos2");
                        closeModal("#dialogLoV");
                    } else {
                        this./*exp*/LanzarVentanaBultos();
                    }
                    $('#campRefer').val("");
                }
            }).bind(this);

            addEvent(btnAccept, 'click', confirmarUbicaciones.bind(this), false);

            $('#dialogPedidos').on('shown.bs.modal', function () {
                code();
            });

            $('#dialogMessage').on('hidden.bs.modal', function () {
                $(btnAccept).prop('disabled', false);
                txtLote.focus();
            });


            $('#dialogLoV .close').on("click", function () {
                restartData();
            });

            //Intentará hacer focus en lote y ubicación, si uno no existe, hará focus en el otro
            //Si existen los 2, hará focus en ubicación
            focusLote(); focusUbic();
            function setUbicLote() {
                if (v_table.rows().count() !== 0) {
                    $('#txtUbic').val(v_table.row('.selected').data().GAUBIC_COD);
                    $('#txtLote').val(v_table.row('.selected').data().LOTE);
                }
            }
        };

        Expedicion.prototype.Reset = function () {
            if (this./*exp*/v_control_lote_ubic === 'SN') {
                $('#txtLote').focus().select();
            } else {
                $('#txtUbic').focus().select();
            }
        };

        //$(window).resize(function () {
        //    cambioTamanioPed();
        //});

        Expedicion.prototype.Ubicacion = function () {
            var cantidad = txtCant.valor();
            if ($.isNumeric(cantidad)) {
                cantidad = eval(cantidad);
                if ($('#tablaUbicaciones').DataTable().rows('.selected').data().length > 0) {
                    var disponible = eval($('#tablaUbicaciones').DataTable().rows('.selected').data()[0].C_UNI1);
                    var pdte = $('#txtPdte').val();
                    var table = $("#tablaUbicaciones").DataTable();
                    this./*exp*/ModCantidades(disponible, eval(cantidad), pdte, table);
                    txtCant.valor(null);
                    $('#txtLote').focus();
                    $('#txtUbic').focus();

                    return true;
                } else {
                    txtCant.valor(null);
                    $('#aceptar').prop('disabled', true);
                    lanzarMensaje(false, Resources.error_batch_not_found, function () { txtCant.foco(); });
                    return false;
                }
            }
        }

        Expedicion.prototype.ModCantidades = function (disponible, cantidad, pdte, table, ubic, lote) {
            disponible = disponible - cantidad;
            pdte = pdte - cantidad;

            var encontrado = false;
            for (i = 0; i < this./*exp*/v_dataClon.Lineas.length && !encontrado; i++) {
                if (TryParseInt(this./*exp*/v_dataClon.Lineas[i].N_LIN, -1) === TryParseInt(this./*exp*/v_posicion_pedido, -2)) {
                    this./*exp*/v_dataClon.Lineas[i].C_PDTE = pdte;
                    encontrado = true;
                }
            }

            $('#txtPdte').val(pdte);
            txtCant.valor(null);
            if (table) {
                table.row('.selected').data().C_UNI1 = disponible;
                table.row('.selected').invalidate();
                //table.cell('.selected td:eq(2)').data( disponible);
                ubic = table.rows('.selected').data()[0].GAUBIC_COD;
                lote = table.rows('.selected').data()[0].LOTE;
            }
            var prod = {
                id: eval($('#tablaPedidos').DataTable().rows('#' + this./*exp*/v_posicion_pedido).data()[0].N_LIN),
                GAUBIC_COD: ubic,
                LOTE: lote,
                C_UNI1: cantidad
            };

            this./*exp*/detallesProd.push(prod);
            this./*exp*/v_pedidoActual_cant = this./*exp*/v_pedidoActual_cant + cantidad;
        };

        Expedicion.prototype.LanzarVentanaBultos = function (dialogName) {
            if (this./*exp*/data.BultosPorLinea) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                dialog = "#dialogPedidos2";
                if (dialogName === "#dialogLoV") {
                    dialog = dialogName;
                }
                var buttons = [
                    generateSingleButton('bultoDetail', Resources.button_details),
                    generateSingleButton('bultoNuevo', Resources.button_new),
                    generateSingleButton('bultoNing', Resources.button_none),
                    generateSingleButton('bultoSelec', Resources.button_select_shrt)
                ];
                var v_columnas = [
                    { "mDataProp": "N_BULTO", name: Resources.table_head_bulto },
                    { "mDataProp": "v_tipoBulto", name: Resources.table_head_description },
                    { "mDataProp": "v_cantidad", name: Resources.table_head_quantity }
                ];
                var columnDefs = [
                    { width: '2em', target: 0 },
                    { width: '4em', target: 2 }
                ];
                var innerDialogs = ['dialogBultoDetail', 'dialogBultoNuevo'];
                generarDialogAuto(url, dialog, 'tablaBultos', null, this./*exp*/bulto, v_columnas, buttons, null, null, this./*exp*/FuncionesBultos, Resources.title_packages, innerDialogs, null, null, null, null, null, columnDefs);
            } else {
                dialogOpening = false;
                this./*exp*/RecogerDetalles();
            }
        };

        Expedicion.prototype.LanzarVentanaBultosDetail = function () {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var buttons = [generateSingleButton('bultoDetailMenu', Resources.button_details, "pull-left"), generateSingleButton('closeDetailMenu', Resources.close)];
            var v_columnas = [
                { "mDataProp": "N_BULTO", name: Resources.table_head_bulto },
                { "mDataProp": "v_tipoBulto", name: Resources.table_head_description },
                { "mDataProp": "v_cantidad", name: Resources.table_head_quantity }
            ];
            var innerDialogs = ['dialogBultoDetailMenu'];
            generarDialogAuto(url, "#dialogLoV", 'tablaBultosDetail', null, this./*exp*/bulto, v_columnas, buttons, null, null, funcionesBultosDetail, Resources.title_packages, innerDialogs);
        };

        Expedicion.prototype.Code = function () {
            if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
                for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
                    if (TryParseInt(v_code.obtenerIdentificadores[i].ia, -1) === 10) {
                        $('#txtUbic').val("");
                        $('#txtLote').val(v_code.obtenerIdentificadores[i].valor);
                        $('#txtLote').trigger(jQuery.Event('keypress', { which: 13 }));
                    }
                    if (TryParseInt(v_code.obtenerIdentificadores[i].ia, -1) === 37) {
                        txtCant.valor(v_code.obtenerIdentificadores[i].valor);
                    }
                }
                $('#detallesUbicacion .selected').click();
                v_code = "";
            }
        };

        return Expedicion;
    });