var data;
var dataAux;
var v_tabla;
var v_dataClon;
var detallesProd;
var v_lineas;
var v_lineas_pedido;
var v_orden_exp;
var v_cant_linea;
var v_pedidoActual_cant;
var bulto;
var v_bultos;
var v_control_lote_ubic;
var v_posicion_pedido;
var dialogOpening;
var v_pedidos_diferentes;

$(window).resize(function () {
    resizePedidos();
});

function resizePedidos() {
    if ($(window).width() < 400) {
        $('#ref .sinLote label').removeClass('col-xs-12').addClass('col-xs-2');

    } else {
        $('#ref .sinLote label').removeClass('col-xs-2').addClass('col-xs-12');
    }
}

function initialize() {
    data;
    dataAux;
    dialogOpening = false;
    v_dataClon;
    detallesProd = [];
    v_lineas;
    v_lineas_pedido = [];
    v_orden_exp = new Array();
    v_cant_linea;
    v_pedidoActual_cant;
    bulto = [];
    v_bultos = [];
    v_control_lote_ubic;
    v_posicion_pedido;
    v_pedidos_diferentes = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), Lineas: [] };
    $('#clientInput').get(0).focus();
}
$(document).ready(function () {

    initialize();
    expedir();
    var v_columns = [
        generateColumn("N_LIN", "ID", false),
        generateColumn("GAART_UBIC_SN", "ID", false),
        generateColumn("GAART_LOTES_SN", "ID", false),
        generateColumn("GAART_COD", Resources.table_head_article, true, false, ''),
        generateColumn("GAART_DESCRIP", Resources.table_head_description, true, false, ''),
        generateColumn("C_PDTE", Resources.table_head_pending, true, true, '')
    ];
    var columnDefs = [
        { "width": "6em", "targets": 3 },
        { "width": "4em", "targets": 5}
    ];
    //var displayLength = ($(window).width() < 400) ? 6 : 8;

    createTableJson('#tablaPedidos', null, v_columns, 1, null, columnDefs);

    //createTableJson('#tablaPedidos', null, v_columns, displayLength);
    v_tabla = $('#tablaPedidos').DataTable();
    cambioTamanioPed();
    // Aquie obtienes mediante DOM el control a traves de ID 
    var btnNuevo = document.getElementById('btnNuevoPedido');
    var cliente = document.getElementById('clientInput');
    var clienteDescrip = document.getElementById('clientDescrip');
    var tableBody = $('#tablaPedidos tbody');
    var btnConfirmar = document.getElementById('confirmar');
    var campCant = document.getElementById('campCant');
    var reference = document.getElementById('campRefer');
    var btnClientSearch = document.getElementById('btnClientSearch');

    addEvent(btnNuevo, 'click', clear, false);
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(cliente).on('keydown', function (e) { pedidosCliente(e); });
    $(cliente).on('change', function (e) { pedidosCliente(e); });
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(reference).on('keydown', function (e) { searchArticleByReference(e); });
    $(reference).on('change', function (e) { searchArticleByReference(e); });
    tableBody.on('click', function (e) { clickTablaPedido(e); });
    addEvent(btnConfirmar, 'click', iniciarExpedicion, false);
    addEvent(campCant, 'change', cantSinLotUb, false);
    addEvent(btnClientSearch, 'click', searchClient, false);
    $(cliente).val("").focus().select();

    function clear() {
        initialize();
        v_tabla.clear().draw();
        $(reference).val("");
        $(cliente).val("").focus().select();
        $(clienteDescrip).val("");
    }


    function pedidosRowData(e) {
        var selectedRow = v_tabla.row(e.target)[0];
        $('#descArticulo').val(v_tabla.rows(selectedRow).data()[0].GAART_DESCRIP);
        $('#ref #campRefer').val(v_tabla.rows(selectedRow).data()[0].GAART_COD);

        var row = $('#tablaPedidos').DataTable().row(selectedRow);
        var LotUbic = row.data().GAART_LOTES_SN + row.data().GAART_UBIC_SN;
        var GGPED_TIP = row.data().GGPEDTIP_COD;
        var N_PEDIDO = row.data().N_PEDIDO;
        var N_lin = row.data().N_LIN;
        var rowID = GGPED_TIP + "-" + N_PEDIDO + "_" + N_lin;
        var $row = $(row.node());
        $row.addClass(LotUbic).prop("id", rowID);
        controlLotUb($row);
    }

    function pedidosCliente(e) {
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //if (e.which === 13 || e.keyCode === 13) {
        {
            var url = "Expedicion/PedidosCliente";
            var method = "GET";
            var v_data = {
                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                emp_cod: sessionStorage.getItem("EMPR_COD"),
                ggclipr_cod: $('#clientInput').val()
            };
            var success = function (response) {
                clear();
                var Ok = function () {
                    data = response.Objeto;

                    $(cliente).val(data.GGCLIPR_COD);
                    $(clienteDescrip).val(data.GGCLIPR_NOMBRE);

                    pintarPedidosCliente();
                };
                var error = function () {
                    $('#clientInput').focus().select();
                };
                handleResponse(response, Ok, error);
            };
            apiGeneral(url, method, v_data, success);
        }
    }

    function pintarPedidosCliente() {
        //data = dataAux;
        // Clon de data para que los datos no sean modificados 
        // en el caso de que se cancele la operación
        v_dataClon = JSON.parse(JSON.stringify(data));

        initialize();
        generarMenu();

        var v_table = $('#tablaPedidos').DataTable();
        v_table.clear().draw();
        if (v_table.rows.length === 0) {
            v_table.rows.add(data.Lineas).draw();
            v_table.columns.adjust().draw()
            console.log($('#tablaPedidos'))
            v_lineas = v_table.rows().data();
            selectRow('#tablaPedidos');
        }
        $('#menuObservaciones').show();

        // Si el pedido tiene alguna observación
        if (data.OBSER) {
            $('#menuObservaciones input').val(Resources.menu_show);
        } else {
            $('#menuObservaciones input').val(Resources.menu_no_observations);
        }

        $('#txtRefer').addClass('col-xs-10');
        $('#txtRefer').removeClass('col-xs-5');
        $('.sinLote').hide();

        $('#campRefer').val("").get(0).focus();
    }

    function cantSinLotUbKey(e) {
        if (e.which === 13) {
            cantSinLotUb(e);
        }
    }

    function clickTablaPedido(event) {
        if (v_lineas.length > 0) {
            if (!dialogOpening) {
                pedidosRowData(event);
                iniciarPedido(event);
            }

        } else {
            $('#confirmar').prop('disabled', true);
        }
    }

    function iniciarPedido(e) {
        var tableRow = $(v_tabla.row(e.target).node());

        //Si no tiene control de lotes ni ubicaciones seguira por la función
        controlLotUb(tableRow);

        //si no, seguira adelante
        if (!tableRow.hasClass('NN')) {
            var promise = comprobarPedidos(tableRow);
            promise.done(function (response) {
                if (response) {

                    dialogOpening = true;
                    v_posicion_pedido = getId($('#tablaPedidos').DataTable().row(tableRow).data());

                    v_lineas = v_tabla.rows().data();
                    v_pedidoActual_cant = 0;
                    detallesProd = [];
                    v_cant_linea = v_tabla.rows(tableRow).data()[0].C_PDTE;
                    v_control_lote_ubic = 'SS';
                    var v_dialog = "#dialogLoV";
                    var v_nombre_tabla = 'tablaUbicaciones';
                    var v_column = [
                        generateColumn('GAUBIC_COD', Resources.table_head_location),
                        generateColumn('LOTE', Resources.table_head_batch),
                        generateColumn('C_UNI1', Resources.table_head_available, true, true)
                    ];
                    var columnDefs = [
                        { "width": "6em", "targets": 0 },
                        { "width": "4em", "targets": 2 }
                    ];
                    if (!tableRow.hasClass('SS')) {
                        var col = tableRow.hasClass('NS') ? true : false;
                        if (col) {
                            v_control_lote_ubic = 'NS';
                            v_column = [
                                generateColumn('GAUBIC_COD', Resources.table_head_location),
                                generateColumn('LOTE', Resources.table_head_batch, false),
                                generateColumn('C_UNI1', Resources.table_head_available, true, true)
                            ];
                            columnDefs = [
                                { "width": "4em", "targets": 2 }
                            ];
                        } else {
                            v_control_lote_ubic = 'SN';
                            v_column = [
                                generateColumn('GAUBIC_COD', Resources.table_head_location, false),
                                generateColumn('LOTE', Resources.table_head_batch),
                                generateColumn('C_UNI1', Resources.table_head_available, true, true)
                            ];
                            columnDefs = [
                                { "width": "4em", "targets": 2 }
                            ];
                        }
                    }
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";
                    var inputs =
                        [
                            generateSingleInput(4, Resources.label_ubicacion, 'txtUbic', '', 'campUbicacion', "focusable"),
                            generateSingleInput(5, Resources.label_lote, 'txtLote', '', 'campLote', "focusable"),
                            generateSingleInput(3, Resources.label_quantity, 'txtCant', '', 'campCant', 'text-right focusable', true)
                        ];
                    var upperInputs =
                        [
                            generateSingleInput(4, Resources.label_ref, 'txtRef', v_tabla.rows(tableRow).data()[0].GAART_COD, 'campRef', '', false, 'text', true),
                            generateSingleInput(5, Resources.label_description, 'txtDescrip', v_tabla.rows(tableRow).data()[0].GAART_DESCRIP, 'campDescrip', '', false, 'text', true),
                            generateSingleInput(3, Resources.label_pending, 'txtPdte', '', 'campPdte', 'text-right', true, 'number', true)
                        ];
                    var buttons = [{ id: 'aceptar', value: Resources.button_accept }];

                    var id = buscarLineaPedido(tableRow.prop('id'));
                    var v_existencias = v_dataClon.Lineas[id].Existencias;
                    generarDialogAuto(url, v_dialog, v_nombre_tabla, null, v_existencias, v_column, buttons, inputs, upperInputs, selectUbicacion,
                        Resources.title_location, ['dialogPedidos2'], null, null, Resources.table_zeroRecordsMessage_no_stock, null, false, columnDefs);
                }
            });
        } else {
            $('#ref #campCant').focus();
        }
    }

    function pedidosCliRowData(e) {
        var selectedRow = v_tabla.row(e.target)[0];
        $('#descArticulo').val(v_tabla.rows(selectedRow).data()[0].GAART_DESCRIP);
        $('#ref #campRefer').val(v_tabla.rows(selectedRow).data()[0].GAART_COD);

        var lotes = v_tabla.rows(selectedRow).data()[0].GAART_LOTES_SN;
        var ubicaciones = v_tabla.rows(selectedRow).data()[0].GAART_UBIC_SN;

        var LotUbic = $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_LOTES_SN + $('#tablaPedidos').DataTable().row(selectedRow).data().GAART_UBIC_SN;
        var N_lin = $('#tablaPedidos').DataTable().row(selectedRow).data().N_LIN;
        $($('#tablaPedidos').DataTable().row(selectedRow).node()).addClass(LotUbic).prop("id", N_lin);
        row = $(v_tabla.row(selectedRow).node());
        controlLotUb(row);
    }

    function comprobarPedidos(tableRow) {
        var deferred = $.Deferred();
        if (v_pedidos_diferentes.Lineas.length !== 0) {
            var posible;
            var v_pedidos_diferentesAux = JSON.parse(JSON.stringify(v_pedidos_diferentes));

            //var tableRow = $(event.target).closest('tr');
            var tableData = $('#tablaPedidos').DataTable().rows(tableRow).data()[0];
            var tipoPed = tableData.GGPEDTIP_COD;
            var numPed = tableData.N_PEDIDO;

            var repetido = false;

            for (var i = 0; i < v_pedidos_diferentesAux.Lineas.length; i++) {
                if (v_pedidos_diferentesAux.Lineas[i].ggpedtip_cod === tipoPed &&
                    v_pedidos_diferentesAux.Lineas[i].n_pedido === numPed) {
                    repetido = true;
                }
            }
            if (!repetido) {
                v_pedidos_diferentesAux.Lineas.push({ ggpedtip_cod: tipoPed, n_pedido: numPed });
            }
            var success = function (response) {
                deferred.resolve(response.Ok);
                if (!response.Ok) {
                    lanzarMensaje(response.Ok, response.Mensaje);
                }
            };

            apiGeneral("expedicion/comprobarpedidos", 'GET', v_pedidos_diferentesAux, success);
            return deferred.promise();
        } else {
            deferred.resolve(true);
            return deferred.promise();
            //iniciarPedido(event);
        }
    }

    function cantSinLotUb() {
        var v_tabla = $('#tablaPedidos').DataTable();
        var selectedRow = v_tabla.row('.selected')[0];
        var promise = comprobarPedidos(selectedRow);
        promise.done(function (response) {
            if (response) {
                v_posicion_pedido = getId($('#tablaPedidos').DataTable().row('.selected').data());
                v_pedidoActual_cant = 0;
                var v_cantVal = $('#ref #campCant').val().trim();
                if ($.isNumeric(v_cantVal) && v_cantVal !== 0) {
                    detallesProd = [];
                    var v_existencias = v_tabla.rows('.selected').data()[0].Existencias;
                    var v_cantidad = eval($('#ref #campCant').val());
                    var existencias = 0;
                    for (i = 0; i < v_existencias.length; i++) {
                        existencias = existencias + v_existencias[i].C_UNI1;
                    }
                    var v_pendiente = eval(v_tabla.rows('.selected').data()[0].C_PDTE);

                    modCantidades(existencias, v_cantidad, v_pendiente);
                    if (data.BultosPorLinea) {
                        dialogOpening = true;
                        lanzarVentanaBultos("#dialogLoV");
                    } else {
                        sinBulto();
                    }
                    $('#ref #campCant').val("");
                }
            }
        });
    }

    function controlLotUb(JQInput) {
        if (JQInput.hasClass('NN')) {
            $('#txtRefer').removeClass('col-xs-10');
            $('#txtRefer').addClass('col-xs-5');
            $('.sinLote').show();
            if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
                for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
                    if (v_code.obtenerIdentificadores[i].ia === "37") {
                        $('#ref #campCant').val(v_code.obtenerIdentificadores[i].valor);
                    }
                }
            }
            $('#ref #campCant').focus();
            resizePedidos();
        } else {
            $('#txtRefer').addClass('col-xs-10');
            $('#txtRefer').removeClass('col-xs-5');
            $('.sinLote').hide();
        }
    }



    function iniciarExpedicion() {
        if (!dialogOpening && data) {
            recogerDatos();
            if ($('#campCant').val() === "") {
                var vacio = true;
                if (v_orden_exp.length !== 0) {
                    for (i = 0; i < v_orden_exp.LINEAS.length; i++) {
                        if (v_orden_exp.LINEAS[i].C_UNI1 !== 0) {
                            vacio = false;
                        }
                    }
                }
                if (!vacio) {
                    transformExpedicion();
                    var url = "expedicion/ResumenBultosPedidosCliente";
                    var datos = v_orden_exp;
                    var method = "PUT";
                    var success = function (response) {
                        var Ok = function () {
                            showDialog("#dialogEnviosEtiquetas");
                            $('.datosEnvio').hide();
                            $('#bultosInput').val(response.Objeto.N_BULTOS);
                            $('#pesoInput').val(response.Objeto.PESO);
                            $('#etiquetasInput').val(response.Objeto.N_ETIQUETAS);
                            $('.datosEtiquetas').show();
                            $("#codTransportistaInput").focus().select();
                        };
                        handleResponse(response, Ok);
                    };

                    apiGeneral(url, method, datos, success);
                } else {
                    lanzarMensaje(false, Resources.error_prep_pedido);
                }
            }
        }

    }
    function buscarLineaPedido(id) {
        for (i = 0; i < data.Lineas.length; i++) {
            if (getId(data.Lineas[i]) === id) {
                return i;
            }
        }
    }

    //Reinicio de la variable v_dataClon actual (
    function restartData() {
        dialogOpening = false;
        if (!data) v_dataClon = JSON.parse(JSON.stringify(data));
    }


    //Busqueda Articulos
    function searchArticleByReference(event) {
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //if (event.which === 13) {
        {

            var encontrado = seleccionFila("#tablaPedidos", [{
                KEY: "GAART_COD",
                VALUE: $('#campRefer').val()
            }]);

            if (encontrado) {
                $('#tablaPedidos .selected').click();
            } else {
                lanzarMensaje(false, Resources.error_article_not_found, function () {
                    $('#campRefer').focus().select();
                });
            }
        }
    }


    //Busqueda Clientes
    function searchClient() {
        var url = "Expedicion/Clientes";
        var method = "GET";
        var v_data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            var Ok = function () {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var v_column = [generateColumn('GGCLIPR_COD', Resources.table_head_code), generateColumn('GGCLIPR_NOMBRE', Resources.table_head_name)];
                var columnDefs = [
                    { width: '6em', targets: 0 }
                ];
                var buttons = [{ id: 'select', value: Resources.button_select }];
                var v_nombre_tabla = "clientTable";
                v_dialog = "#dialogLoV";
                generarDialogAuto(url, v_dialog, v_nombre_tabla, null, response.Objeto, v_column, buttons, null, null, selectClient, Resources.title_clients, null, null, null, Resources.table_zeroRecordsMessage_no_clients, null, false, columnDefs, true);
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, v_data, success);
    }

    function selectClient() {
        var btnSelect = document.getElementById('select');

        addEvent(btnSelect, 'click',
            function () {
                var clientCod = $('#clientTable').DataTable().rows('.selected').data()[0].GGCLIPR_COD;
                var e = $.Event("keypress", { which: 13 });
                $('#clientInput').val(clientCod);
                pedidosCliente(e);
                closeModal('#dialogLoV');
            }, false);
    }
});
function restartData() {
    v_dataClon = JSON.parse(JSON.stringify(data));
}
var v_numBulto = 0;
v_posicion_pedido
function funcionesBultos() {
    dialogOpening = false;
    if (bulto.length > 0) {
        $('#bultoDetail').prop('disabled', false);
        $('#bultoSelec').prop('disabled', false);
    } else {
        $('#bultoDetail').prop('disabled', true);
        $('#bultoSelec').prop('disabled', true);
    }

    /**
    *   Botones de bultos
    */
    var btnBultoDetail = document.getElementById('bultoDetail');
    var btnBultoNuevo = document.getElementById('bultoNuevo');
    var btnBultoNinguno = document.getElementById('bultoNing');
    var btnBultoSelec = document.getElementById('bultoSelec');

    /**
    *   Funciones de los botones de las ventanas de bultos
    */
    addEvent(btnBultoDetail, 'click', ventanaBultosDetail, false);
    addEvent(btnBultoNuevo, 'click', ventanaBultosNuevo, false);
    addEvent(btnBultoNinguno, 'click', sinBulto, false);
    addEvent(btnBultoSelec, 'click', seleccionarBulto, false);
}

function ventanaBultosDetail() {
    var v_tabla = $('#tablaBultos').DataTable();
    var v_idBulto = eval(v_tabla.rows('.selected').data()[0].N_BULTO);
    var v_columnas = [
        generateColumn('GAART_COD', Resources.table_head_code),
        generateColumn('GAART_DESCRIP', Resources.table_head_description),
        generateColumn('C_UNI1', Resources.table_head_quantity, true, true)
    ];
    var columnDefs = [
        { width: '6em', targets: 0 },
        { width: '4em', targets: 2 }
    ];
    //var url = Router.action('Dialog', 'Dialog');
    var url = "Dialog/Dialog";

    var buttons = [generateSingleButton('detBultoAceptar', Resources.button_accept)];
    generarDialogAuto(url, "#dialogBultoDetail", 'tablaDetallesBulto', null, bulto[v_idBulto - 1]['v_articulos'], v_columnas, buttons, null, null, detallesBulto, Resources.title_packages, null, null, null, Resources.zeroRecordsMessage, null, null, columnDefs);
}

function ventanaBultosNuevo() {
    var url = "expedicion/tipospale";
    var method = "GET";
    var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") };
    var success = function (response) {
        var Ok = function () {
            //var url = Router.action('Dialog', 'Dialog');
            var url = "Dialog/Dialog";
            var v_data = response.Objeto;
            var v_columnas = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
            var columnDefs = [
                { width: '6em', targets: 0 }
            ];
            var buttons = [generateSingleButton('tipoBultoSelec', Resources.button_select)];
            generarDialogAuto(url, "#dialogBultoNuevo", 'tablaTiposBulto', null, v_data, v_columnas, buttons, null, null, bultoNuevo, Resources.title_packages_new, null, null, null, Resources.zeroRecordsMessage, null, null, columnDefs);
        };
        handleResponse(response, Ok);
    };
    apiGeneral(url, method, datos, success);
}

function sinBulto() {
    recogerDetalles();
    closeModal("#dialogPedidos2");
    closeModal("#dialogLoV");
}

function seleccionarBulto() {
    var v_tabla = $('#tablaBultos').DataTable();
    seleccionBulto(v_tabla.rows('.selected').data()[0].N_BULTO);

    recogerDetalles();
    closeModal("#dialogPedidos2");
    closeModal("#dialogLoV");
}

function funcionesBultosDetail() {

    if (bulto.length > 0) {
        $('#bultoDetailMenu').prop('disabled', false);
    } else {
        $('#bultoDetailMenu').prop('disabled', true);
    }
    $('#bultoDetailMenu').on("click", function () {
        var v_tabla = $('#tablaBultosDetail').DataTable();
        var v_idBulto = eval(v_tabla.rows('.selected').data()[0].N_BULTO);
        var v_columnas = [
            generateColumn('GAART_COD', Resources.table_head_code),
            generateColumn('GAART_DESCRIP', Resources.table_head_description),
            generateColumn('C_UNI1', Resources.table_head_quantity, true, true)
        ];
        var columnDefs = [
            { width: "6em", target: 0 },
            { width: "4em", target: 2 }
        ];
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";

        var buttons = [generateSingleButton('detBultoAceptarMenu', Resources.close)];

        generarDialogAuto(url, "#dialogBultoDetailMenu", 'tablaDetallesBulto1', null, bulto[v_idBulto - 1]['v_articulos'], v_columnas, buttons, null, null, detallesBultoMenu, Resources.packages, null, null, null, null, null, null, columnDefs);
    });

    $('#closeDetailMenu').on('click', function () {
        closeModal("#dialogLoV");
    });
}

function detallesBultoMenu() {
    var btnDialogDetailMenuClose = $("#dialogBultoDetailMenu .close").get(0);
    var btnDetallesBultoAceptarMenu = document.getElementById("detBultoAceptarMenu");

    addEvent(btnDialogDetailMenuClose, 'click', closeMenuDetail, false);
    addEvent(btnDetallesBultoAceptarMenu, 'click', acceptMenuDetail, false);

    function closeMenuDetail(event) {
        closeModal("#dialogBultoDetailMenu");
        event.preventDefault();
        event.stopPropagation();
        return false;
    }

    function acceptMenuDetail() {
        closeModal("#dialogBultoDetailMenu");
    }
}

function detallesBulto() {

    var btnDialogDetailClose = $("#dialogBultoDetail .close").get(0);
    var btnDetallesBultoAceptar = document.getElementById("detBultoAceptar");
    addEvent(btnDialogDetailClose, 'click', ventanaBultoDetailClose, false);
    addEvent(btnDetallesBultoAceptar, 'click', acceptDetail, false);


    function ventanaBultoDetailClose(event) {
        closeModal("#dialogBultoDetail");
        event.preventDefault();
        event.stopPropagation();
        return false;
    }

    function acceptDetail() {
        closeModal("#dialogBultoDetail");
    }
}

function bultoNuevo() {
    //var btnBultoNuevoClose = $("#dialogBultoNuevo .close").get(0);
    var btnTipoBultoSelec = $('#tipoBultoSelec').get(0);  

    //addEvent(btnBultoNuevoClose, 'click', bultoNuevoClose, false);
    addEvent(btnTipoBultoSelec, 'click', tipoBultoSelec, false);

    function bultoNuevoClose() {
        closeModal("#dialogBultoNuevo");
        event.preventDefault();
        event.stopPropagation();
        return false;
    }

    function tipoBultoSelec() {
        nuevoBulto();
        recogerDetalles();
        closeModal("#dialogBultoNuevo");
        closeModal("#dialogPedidos2");
        closeModal("#dialogLoV");
    }
}


function recogerDatos() {
    v_orden_exp = {
        EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
        EMP_COD: sessionStorage.getItem("EMPR_COD"),
        N_BULTOS: bulto.length,
        F_ALBARAN: getFechaAlbaran(),
        Bultos: bulto,
        LINEAS: v_lineas_pedido
    };
}

//Añade el pedido a la comprobación de compatibilidad entre pedidos
function addComprobacion() {
    var tableData = $('#tablaPedidos').DataTable().rows('.selected').data()[0];
    var tipoPed = tableData.GGPEDTIP_COD;
    var numPed = tableData.N_PEDIDO;

    var v_repetido = false;

    for (var i = 0; i < v_pedidos_diferentes.Lineas.length; i++) {
        if (v_pedidos_diferentes.Lineas[i].ggpedtip_cod === tipoPed &&
            v_pedidos_diferentes.Lineas[i].n_pedido === numPed) {
            v_repetido = true;
        }
    }

    if (!v_repetido) {
        var lineas = [];
        lineas.push({ ggpedtip_cod: tipoPed, n_pedido: numPed });
        v_pedidos_diferentes.Lineas = lineas;
    }
}
function recogerDetalles() {
    addComprobacion();

    encontrado = false;
    for (i = 0; i <= v_lineas_pedido.length && !encontrado; i++) {
        for (j = 0; j < detallesProd.length && !encontrado; j++) {
            if (i === v_lineas_pedido.length) {
                v_lineas_pedido.push({ 'C_UNI1': eval(detallesProd[j].C_UNI1), 'N_LIN': eval(detallesProd[j].N_LIN), 'GGPEDTIP_COD': detallesProd[j].GGPEDTIP_COD, 'N_PEDIDO': detallesProd[j].N_PEDIDO, "Detalles": detallesProd });
                encontrado = true;
            } else if (getId(v_lineas_pedido[i]) === getId(detallesProd[j])) {
                if (!repetido(i) && (detallesProd[j].GAUBIC_COD || detallesProd[j].LOTE)) {
                    v_lineas_pedido[i]["Detalles"].push(detallesProd[j]);
                }

                v_lineas_pedido[i]['C_UNI1'] = v_lineas_pedido[i]['C_UNI1'] + eval(detallesProd[j].C_UNI1);
                encontrado = true;
            }
        }
    }

    var pos_v_lineas;
    var encontrado = false;

    data = JSON.parse(JSON.stringify(v_dataClon));

    for (i = 0; i < v_lineas.length && !encontrado; i++) {
        var v_table_data = $('#tablaPedidos').DataTable().rows('#' + v_posicion_pedido).data()[0];
        var v_table_id = getId(v_table_data);
        var v_id = getId(data.Lineas[i]);

        if (v_id === v_table_id) {
            pos_v_lineas = i;
            encontrado = true;
        }
    }


    var v_table = $('#tablaPedidos').DataTable();
    v_table.row('#' + v_posicion_pedido).data(data.Lineas[pos_v_lineas]).draw();
    cambioColorPedido(v_lineas_pedido);
    actualizarBultos();
}

function cambioColorPedido(v_lineas_pedido) {
    var v_table = $('#tablaPedidos').DataTable();
    var row = v_table.row('#' + v_posicion_pedido).node();


    for (i = 0; i < v_lineas_pedido.length; i++) {
        if (getId(v_lineas_pedido[i]) === v_posicion_pedido && v_lineas_pedido[i].C_UNI1 !== 0) {
            if (!$(row).hasClass('green')) {

                $(row).addClass('green');
            }

            return;
        }
    }
}


function repetido(i) {
    for (k = 0; k < v_lineas_pedido[i]["Detalles"].length; k++) {
        if (detallesProd[j]['LOTE'] === v_lineas_pedido[i]["Detalles"][k]['LOTE'] && detallesProd[j]['GAUBIC_COD'] === v_lineas_pedido[i]["Detalles"][k]['GAUBIC_COD']) {
            v_lineas_pedido[i]["Detalles"][k]['C_UNI1'] = eval(v_lineas_pedido[i]["Detalles"][k]['C_UNI1']) + eval(detallesProd[j]['C_UNI1']);
            return true;
        }
    }
    return false;
}

function seleccionBulto(numBulto) {
    generarBulto(numBulto);
}

function nuevoBulto() {
    generarBulto(null);
}

function generarBulto(numBulto) {
    var v_articulo = new Array();
    var v_articulos = new Array();
    var v_NUM_Pedido = $("#N_PEDIDO").val();
    var v_cantidad = prod.C_UNI1;
    var v_tablaPed = $('#tablaPedidos').DataTable();
    var v_datos_articulo = v_tablaPed.rows('#' + v_posicion_pedido).data()[0];
    var v_N_LIN = v_datos_articulo.N_LIN;
    var v_descr_articulo = v_datos_articulo.GAART_COD;
    var v_nombre_articulo = v_datos_articulo.DESCRIP;
    var v_ggpedtip_cod = v_datos_articulo.GGPEDTIP_COD;
    var v_n_pedido = v_datos_articulo.N_PEDIDO;
    //v_nombre_articulo = $('#descArticulo').val();    
    console.log('Numero de bultop > ', numBulto)
    if (!numBulto) {
        v_numBulto = v_numBulto + 1;
        v_tablaTiposBulto = $('#tablaTiposBulto').DataTable();
        v_tipoBulto = v_tablaTiposBulto.rows('.selected').data()[0].COD;

        v_articulos.push({
            N_BULTO: v_numBulto,
            GGPEDLIN_N_LIN: v_N_LIN,
            GGPEDLIN_GGPEDTIP_COD: v_ggpedtip_cod,
            GGPEDLIN_N_PEDIDO: v_n_pedido,
            GAART_COD: v_descr_articulo,
            C_UNI1: v_cantidad,
            GAART_DESCRIP: v_nombre_articulo
        });

        bulto.push({
            N_BULTO: v_numBulto,
            GGPEDLIN_N_LIN: v_N_LIN,
            GGPEDLIN_GGPEDTIP_COD: v_ggpedtip_cod,
            GGPEDLIN_N_PEDIDO: v_n_pedido,
            v_articulos,
            v_tipoBulto,
            v_cantidad: eval(v_cantidad)
        });
    } else {
        v_numBulto = numBulto;
        v_articulos.push({
            N_BULTO: v_numBulto,
            GGPEDLIN_N_LIN: v_N_LIN,
            GGPEDLIN_GGPEDTIP_COD: v_ggpedtip_cod,
            GGPEDLIN_N_PEDIDO: v_n_pedido,
            GAART_COD: v_descr_articulo,
            C_UNI1: v_cantidad,
            GAART_DESCRIP: v_nombre_articulo
        });
        addBulto(numBulto, v_articulos[0]);
    }
}

function addBulto(numBulto, articulos) {
    var encontrado = false;
    numBulto = numBulto - 1;
    var v_articulosBulto = bulto[eval(numBulto)]["v_articulos"];
    for (var i = 0; i < v_articulosBulto.length && !encontrado; i++) {
        if (v_articulosBulto[i]["GGPEDLIN_N_LIN"] === articulos['GGPEDLIN_N_LIN']) {
            v_articulosBulto[i]["C_UNI1"] = v_articulosBulto[i]["C_UNI1"] + articulos['C_UNI1'];
            encontrado = true;
        }
    }
    if (!encontrado) {
        bulto[numBulto]["v_articulos"].push(articulos);
    }
    bulto[numBulto]['v_cantidad'] = bulto[numBulto]['v_cantidad'] + prod.C_UNI1;
}

function getId(object) {
    return object.GGPEDTIP_COD + "-" + object.N_PEDIDO + "_" + object.N_LIN;
}
$(document).ready(function () {
    //seleccionTransporte();

    inicializarEventos();

});
function inicializarEventos() {
    // Aqui obtienes mediante DOM el control a traves de ID
    var inpTransportista = document.getElementById('codTransportistaInput');
    var inpVehiculo = document.getElementById('codVehiculoInput');
    var btnTransporterSearch = document.getElementById('transporterSearch');
    var btnVehicleSearch = document.getElementById('vehicleSearch');
    var bultosInput = document.getElementById('bultosInput');
    var pesoInput = document.getElementById('pesoInput');
    var etiquetasInput = document.getElementById('etiquetasInput');

    addEvent(inpTransportista, 'change', transporterChange, false);
    addEvent(inpVehiculo, 'change', vehicleChange, false);
    addEvent(btnTransporterSearch, 'click', transporterSearch, false);
    addEvent(btnVehicleSearch, 'click', vehicleSearch, false);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(bultosInput).keypress(function (e) { if (e.which == 13) focusPeso() });
    //$(pesoInput).keypress(function (e) { if (e.which == 13) focusEtiquetas() });
    //$(etiquetasInput).keypress(function (e) { if (e.which == 13) focusTransport() });
    //$(inpTransportista).keypress(function (e) { if (e.which == 13) focusVehicle() });
    //$(inpVehiculo).keypress(function (e) { if (e.which == 13) focusBultos() });
    //$(bultosInput).on("change", function (e) { focusPeso() });
    //$(pesoInput).on("change", function (e) { focusEtiquetas() });
    //$(etiquetasInput).on("change", function (e) { focusTransport() });
    //$(inpTransportista).on("change", function (e) { focusVehicle() });
    //$(inpVehiculo).on("change", function (e) { focusBultos() });

    function focusTransport() {
        $(inpTransportista).focus().select();
    }

    function focusVehicle() {
        $(inpVehiculo).focus().select();
    }

    function focusBultos() {
        $("#bultosInput").focus().select();
    }
    function focusPeso() {
        $("#pesoInput").focus().select();
    }
    function focusEtiquetas() {
        $("#etiquetasInput").focus().select();
    }



    function transporterChange() {
        if ($(this).val() !== '') {
            var url = "expedicion/ModoEnvio";
            var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GGMENVIO_COD: $(this).val() }
            var method = "GET";
            var success = function (response, status, xhr) {
                if (response.Ok) {
                    $('#codTransportistaInput').val(response.Objeto.COD);
                    $('#nombreTransportistaInput').val(response.Objeto.DESCRIP);
                    $(inpVehiculo).focus().select();
                    limpiarVehiculos();
                } else {
                    $('#nombreTransportistaInput').val("");
                    $(inpTransportista).focus().select();
                    limpiarVehiculos();
                    lanzarMensaje(false, response.Mensaje, focusTransport);
                }
            }

            apiGeneral(url, method, datos, success);
        } else {
            $('#nombreTransportistaInput').val("");
            limpiarVehiculos();
        }
    }



    function vehicleChange() {
        if ($(this).val() !== '') {
            var url = "expedicion/Vehiculo";
            var v_datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').val(), cod: $(this).val() }
            var method = "GET";
            var success = function (response) {
                if (response.Ok) {
                    $('#codVehiculoInput').val(response.Objeto.COD);
                    $('#descrVehiculoInput').val(response.Objeto.DESCRIP);
                } else {
                    $('#descrVehiculoInput').val('');
                    lanzarMensaje(false, response.Mensaje, focusVehicle);
                }
            }
            apiGeneral(url, method, v_datos, success);
        } else {
            limpiarVehiculos();
        }
    }

    function transporterSearch() {
        var url = "expedicion/ModosEnvio";
        var method = "GET";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") }
        var success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var v_columns = [
                    generateColumn('COD', Resources.table_head_code),
                    generateColumn('DESCRIP', Resources.table_head_description)
                ];
                var columnDefs = [
                    { width: "6em", target: 0 }
                ];
                var v_buttons = [generateSingleButton("datosEnvioAccept", Resources.button_accept)];
                generarDialogAuto(url, "#dialogLoV", "tableTransporter", null, response.Objeto, v_columns, v_buttons, null, null, transporterFunctions, Resources.title_shipping_data, null, null, null, null, null, null, columnDefs, true);
            } else {
                lanzarMensaje(response.Ok, response.Mensaje)
            }
        }
        apiGeneral(url, method, datos, success);
    }

    function vehicleSearch() {
        var url = "expedicion/Vehiculos";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').prop('value') }
        var method = "GET";
        var success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var v_columns = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
                var columnDefs = [
                    { width: "6em", target: 0 }
                ];
                var v_buttons = [generateSingleButton("datoEnvioAccept", Resources.button_accept)];
                generarDialogAuto(url, "#dialogLoV", "tableVehicle", null, response.Objeto, v_columns, v_buttons, null, null, vehicleFunctions, Resources.title_shipping_vehicle_data, null, null, null, null, null, null, columnDefs, true);
            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
        }
        apiGeneral(url, method, datos, success);
    }

    // pedidos_pedidos: L223
    function envioAceptar() {
        var url = "expedicion/Vehiculo";
        var v_datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').val(), cod: $('#codVehiculoInput').val() }
        var method = "GET";
        var success = function (response) {
            if (response.Ok) {
                datosEnvio();
                $('#dialogEnviosEtiquetas').modal('hide');
            } else {
                $('#descrVehiculoInput').val('');
                lanzarMensaje(false, response.Mensaje);
            }
        }
        apiGeneral(url, method, v_datos, success);
    }

    function transporterFunctions() {
        $('.close').on("click", function () {
            closeModal("#dialogDatosEnvio");
        });
        $('#datosEnvioAccept').on("click", function () {
            var v_table = $("#tableTransporter").DataTable();
            if (v_table.rows().data().length > 0) {
                var v_codTransportista = v_table.rows('.selected').data()[0].COD;
                var v_nombreTransportista = v_table.rows('.selected').data()[0].DESCRIP;
                $('#codTransportistaInput').val(v_codTransportista);
                $('#nombreTransportistaInput').val(v_nombreTransportista);
                limpiarVehiculos();
            }
            closeModal('#dialogLoV');
        });
    }

    function vehicleFunctions() {
        $('.close').on("click", function () {
            closeModal("#dialogDatosEnvio");
        });
        $('#datoEnvioAccept').on("click", function () {
            var v_table = $("#tableVehicle").DataTable();
            var v_data_table = v_table.rows('.selected').data();
            if (v_data_table.length !== 0) {
                var v_codVehiculo = v_data_table[0].COD;
                var v_descrVehiculo = v_data_table[0].DESCRIP;
                if (v_table.rows().data().length > 0) {
                    $('#codVehiculoInput').val(v_codVehiculo);
                    $('#descrVehiculoInput').val(v_descrVehiculo);
                }
            }
            closeModal('#dialogLoV');
        });
    }


    function limpiarVehiculos() {
        $('#codVehiculoInput').val("");
        $('#descrVehiculoInput').val("");
    }
};

function datosEnvio() {
    v_orden_exp.GGMENVIO_COD = $('#codTransportistaInput').val();
    v_orden_exp.GGVEHICULO_COD = $('#codVehiculoInput').val();
}

function expedir() {
    var btnContinueExped = document.getElementById('ContinuarExped');
    var btnPrintExped = document.getElementById('ImprimirExped');

    addEvent(btnContinueExped, 'click', continueExped, false);
    addEvent(btnPrintExped, 'click', printExped, false);

}

function continueExped() {
    datosEnvio();
    generarExpedicion();
}
function printExped() {
    datosEnvio();
    imprimirExpedicion();
}

function imprimirExpedicion() {

    //Recoger datos restantes de expedición
    transformExpedicion();
    v_orden_exp.N_BULTOS = $('#bultosInput').val();
    v_orden_exp.N_ETIQUETAS = $('#etiquetasInput').val();
    v_orden_exp.PESO = $('#pesoInput').val();

    //Params Expedir
    var url = "expedicion/ExpedirPedidosCliente";
    var data = v_orden_exp;
    var method = "POST";
    var success = function (response) {
        //Params Impresión etiquetas
        var url = "impresion/imprimiretiqueta";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            ggalbtip_cod: response.Objeto.GGALBTIP_COD,
            n_albaran: response.Objeto.N_ALBARAN
        };
        var method = 'PUT';
        var success = function (response) {
            //var url = Router.action('Expedicion', 'Index');
            var url = "Expedicion/Index";
            lanzarMensajeRedirect(response.Ok, response.Mensaje, url);
        };
        //API CALL Impresión de etiquetas
        apiGeneral(url, method, data, success, null, completedLoading);
    };

    //API CALL Expedición
    apiGeneral(url, method, data, success, startLoading);
}

function generarExpedicion() {
    transformExpedicion();
    v_orden_exp.N_BULTOS = $('#bultosInput').val();
    v_orden_exp.N_ETIQUETAS = $('#etiquetasInput').val();
    v_orden_exp.PESO = $('#pesoInput').val();

    //Params
    var url = "expedicion/ExpedirPedidosCliente";
    var data = v_orden_exp;
    var method = "POST";
    var success = function (response) {
        //var url = Router.action('PedidosCliente', 'Index');
        var url = "PedidosCliente/Index";
        lanzarMensajeRedirect(response.Ok, response.Mensaje, url);
    };

    //API call
    apiGeneral(url, method, data, success, startLoading, completedLoading);
}

function transformExpedicion() {
    if (eval(v_orden_exp.N_BULTOS) > 0 && v_orden_exp.Bultos.length > 0 && v_orden_exp.Bultos[0].v_articulos) {
        v_bultos = [];
        for (var i = 0; i < v_orden_exp.Bultos.length; i++) {
            for (j = 0; j < v_orden_exp.Bultos[i].v_articulos.length; j++) {
                v_orden_exp.Bultos[i].v_articulos[j].GVPALLETIP_COD = v_orden_exp.Bultos[i].v_tipoBulto;
                v_bultos.push(v_orden_exp.Bultos[i].v_articulos[j]);
            }
        }
        v_orden_exp.Bultos = v_bultos;
    }
}
function menuInit() {
    //Inicializa el menu cada vez que se introduce un nuevo pedido dejando el botón de desconexión
    $('#nav-user').find('li:not(:first)').remove();
}

function generarMenu() {

    menuInit();
    menuElement(Resources.menu_delivery_note_date, 'fecha', '#', dateToString(new Date()), 'buscador', 'menuDate');

    menuElement(Resources.menu_observations, 'observaciones', '#', "Mostrar", '', 'menuObservaciones');

    menuDatePicker();

    $('#menuObservaciones').on('click', function () {
        if (typeof data !== 'undefined') {
            if (data != null) {
                if (data.OBSER != null && data.OBSER.trim() != "")
                    lanzarMensaje(true, data.OBSER);
                else
                    lanzarMensaje(true, Resources.message_no_observations)
            } else {
                lanzarMensaje(false, Resources.error_insert_order);
            }
        }
    });
}

//function menuElement(name, icon, href, value, valueIcon, id) {
//    var menuHtml = '<li id="' + id + '" class="col-xs-12 pull-left"> \
//                            <a href="' + href + '"><i class="glyphicon glyphicon-' + icon + '"></i>&nbsp;&nbsp;' + name;
//    if (value != '') {
//        menuHtml = menuHtml + '<div class="pull-right text-right"><input class="invisible-input" readonly value="' + value + '">&nbsp;<i class="glyphicon glyphicon-' + valueIcon + '"> </i></div>';
//    }
//    menuHtml = menuHtml + '</a></li>';

//    $('#nav-user').append(menuHtml);
//}

function actualizarBultos() {
    $('#menuBultos div input').val(Resources.menu_package_quantity + ": " + bulto.length);
}
function selectUbicacion() {
    dialogOpening = false;

    var v_table = $('#tablaUbicaciones').DataTable();

    var txtCant = $('#txtCant');
    var txtLote = $('#txtLote');
    var txtUbic = $('#txtUbic');
    var btnAccept = document.getElementById('aceptar');

    addEvent(btnAccept, 'click', function () { ubicacion(); confirmarUbicaciones(); }, false);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtUbic.keypress(function (e) {
    //    if (e.which === 13 && $(this).val() !== "") {
    txtUbic.on("change", function (e) {
        if ($(this).val() !== "") {
            getUbic();
            setTimeout(function () {
                focusCant();
                focusLote();
            });
            e.preventDefault();
        }
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtLote.keypress(function (e) {
    //    if (e.which === 13 && $(this).val() !== "") {
    txtLote.on("change", function (e) {
        if ($(this).val() !== "") {
            getLote();
            focusCant();
            e.preventDefault();
        }
    });

    function getUbic() {
        var arrayBusqueda = [];
        arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() });
        var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
        if (v_control_lote_ubic === 'NS') {
            if (existeFila) $('#tablaUbicaciones .selected').click();
        } else {
            setUbicLote();
        }
    }

    function getLote() {
        var arrayBusqueda = [];
        if (v_control_lote_ubic === 'SN') {
            arrayBusqueda.push({ KEY: 'LOTE', VALUE: $('#txtLote').val() });
        } else {
            arrayBusqueda.push({ KEY: 'GAUBIC_COD', VALUE: $('#txtUbic').val() }, { KEY: 'LOTE', VALUE: $('#txtLote').val() });
        }
        var existeFila = seleccionFila("#tablaUbicaciones", arrayBusqueda);
        if (existeFila) $('#tablaUbicaciones .selected').click();
    }

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtCant.keypress(function (e) {
    //    if (e.which === 13) {
    txtCant.on("change", function (e) {
        {
            if ($(this).val()) ubicacion();
        }
    });

    if (v_control_lote_ubic === 'SN') {
        $('#campUbicacion').hide();
        $('#campLote').removeClass('col-xs-5');
        $('#campLote').addClass('col-xs-7');
        $('#campCant').removeClass('col-xs-3');
        $('#campCant').addClass('col-xs-5');
    } else if (v_control_lote_ubic === 'NS') {
        $('#campLote').hide();
        $('#campUbicacion').removeClass('col-xs-4');
        $('#campUbicacion').addClass('col-xs-7');
        $('#campCant').removeClass('col-xs-3');
        $('#campCant').addClass('col-xs-5');
    }

    $("#txtPdte").val(v_cant_linea);

    $('#tablaUbicaciones').on("click", "tr", function () {
        if (v_table.rows().count() !== 0) {
            focusCant();
            $('#txtUbic').val(v_table.rows($(this)).data()[0].GAUBIC_COD);
            $('#txtLote').val(v_table.rows($(this)).data()[0].LOTE);

            var pendiente = v_table.row($(this)).data().C_UNI1;
            var cantidadAServir = $('#txtPdte').val();
            var cant = setOptimumQty(pendiente, cantidadAServir);
            $('#txtCant').val(cant);
        }
    });
    function confirmarUbicaciones() {
        if (v_pedidoActual_cant !== 0) {
            lanzarVentanaBultos();
        }
    }

    $('#dialogPedidos').on('shown.bs.modal', function () {
        code();
    });

    $('#dialogMessage').on('hidden.bs.modal', function () {
        $(btnAccept).prop('disabled', false);
        resetFocus();
    });

    $('#dialogLoV .close').on("click", function () {
        restartData();
    });

    resetFocus();

    function setUbicLote() {
        if (v_table.rows('.selected').count() !== 0) {
            $('#txtUbic').val(v_table.row('.selected').data().GAUBIC_COD);
            $('#txtLote').val(v_table.row('.selected').data().LOTE);
        }
    }
}
function resetFocus() {
    focusLote();
    focusUbic();
}
function focusUbic() {
    $('#txtUbic').focus().select();
}

function focusLote() {
    $('#txtLote').focus().select();
}

function focusCant() {
    $('#txtCant').focus().select();
}
function clickOnSelected() {
    if ($("#tablaUbicaciones").DataTable().rows().count !== 0) {
        $('#tablaUbicaciones .selected').click();
    }
}

$(window).resize(function () {
    cambioTamanioPed();
});

function ubicacion() {
    var cantidad = $('#txtCant').val();
    if ($.isNumeric(cantidad)) {
        cantidad = eval(cantidad);
        if ($('#tablaUbicaciones').DataTable().rows('.selected').data().length > 0) {
            var disponible = eval($('#tablaUbicaciones').DataTable().rows('.selected').data()[0].C_UNI1);
            var pdte = $('#txtPdte').val();
            var table = $("#tablaUbicaciones").DataTable();
            modCantidades(disponible, eval(cantidad), pdte, table);
            $('#txtCant').val("");
            $('#txtLote').focus();
            $('#txtUbic').focus();
            return true;
        } else {
            $('#txtCant').val("");
            resetFocus();
            $('#aceptar').prop('disabled', true);
            lanzarMensaje(false, Resources.error_batch_not_found, focusCant);
            return false;
        }
    }
    return false;
}

function modCantidades(disponible, cantidad, pdte, table, ubic, lote) {
    disponible = disponible - cantidad;
    pdte = pdte - cantidad;

    var encontrado = false;
    for (i = 0; i < v_dataClon.Lineas.length && !encontrado; i++) {
        if (getId(v_dataClon.Lineas[i]) === v_posicion_pedido) {
            v_dataClon.Lineas[i].C_PDTE = pdte;
            encontrado = true;
        }
    }
    $('#txtPdte').val(pdte);
    $('#txtCant').val("");
    if (table) {
        table.cell('.selected td:eq(2)').data(disponible);
        ubic = table.rows('.selected').data()[0].GAUBIC_COD;
        lote = table.rows('.selected').data()[0].LOTE;
    }
    var datos = $('#tablaPedidos').DataTable().rows('#' + v_posicion_pedido).data()[0];
    prod = new Array();
    prod = {
        GGPEDTIP_COD: datos.GGPEDTIP_COD,
        N_PEDIDO: datos.N_PEDIDO,
        N_LIN: eval(datos.N_LIN),
        GAUBIC_COD: ubic,
        LOTE: lote,
        C_UNI1: cantidad
    };
    detallesProd.push(prod);
    v_pedidoActual_cant = v_pedidoActual_cant + cantidad;
}


function lanzarVentanaBultos(dialogName) {
    if (data.BultosPorLinea) {
        //var url = Router.action('Dialog', 'Dialog');
        var url = "Dialog/Dialog";
        dialog = "#dialogPedidos2";
        if (dialogName === "#dialogLoV") {
            dialog = dialogName;
        }
        var buttons = [generateSingleButton('bultoDetail', Resources.button_details), generateSingleButton('bultoNuevo', Resources.button_new), generateSingleButton('bultoNing', Resources.button_none), generateSingleButton('bultoSelec', Resources.button_select_shrt)];
        var v_columnas = [
            { "mDataProp": "N_BULTO", name: Resources.table_head_bulto },
            { "mDataProp": "v_tipoBulto", name: Resources.table_head_description },
            { "mDataProp": "v_cantidad", name: Resources.table_head_quantity }
        ];

        var columnDefs = [
            { width: "2em", target: 0 },
            { width: "4em", target: 2 }
        ];
        var innerDialogs = ['dialogBultoDetail', 'dialogBultoNuevo'];
        generarDialogAuto(url, dialog, 'tablaBultos', null, bulto, v_columnas, buttons, null, null, funcionesBultos, Resources.title_packages, innerDialogs, null, null, null, null, null, columnDefs);
    } else {
        sinBulto();
    }

}

function lanzarVentanaBultosDetail() {
    //var url = Router.action('Dialog', 'Dialog');
    var url = "Dialog/Dialog";
    var buttons = [generateSingleButton('bultoDetailMenu', Resources.button_details, "pull-left"), generateSingleButton('closeDetailMenu', Resources.close)];
    var v_columnas = [
        { "mDataProp": "N_BULTO", name: Resources.table_head_bulto },
        { "mDataProp": "v_tipoBulto", name: Resources.table_head_description },
        { "mDataProp": "v_cantidad", name: Resources.table_head_quantity }
    ];
    var columnDefs = [
        { width: "2em", target: 0 },
        { width: "4em", target: 2 }
    ];
    var innerDialogs = ['dialogBultoDetailMenu'];
    generarDialogAuto(url, "#dialogLoV", 'tablaBultosDetail', null, bulto, v_columnas, buttons, null, null, funcionesBultosDetail, Resources.title_packages, innerDialogs, null, null, null, null, null, columnDefs);
}

function code() {
    if (typeof v_code !== 'undefined' && v_code !== "" && v_code.obtenerIdentificadores.length > 0) {
        for (i = 0; i < v_code.obtenerIdentificadores.length; i++) {
            if (v_code.obtenerIdentificadores[i].ia === 10) {
                $('#txtUbic').val("");
                $('#txtLote').val(v_code.obtenerIdentificadores[i].valor);
                $('#txtLote').trigger(jQuery.Event('keypress', { which: 13 }));
            }
            if (v_code.obtenerIdentificadores[i].ia === 37) {
                $('#txtCant').val(v_code.obtenerIdentificadores[i].valor);
            }
        }
        $('#detallesUbicacion .selected').click();
        v_code = "";
    }
}
var v_albaranSeleccionado;

function selectAlbaran() {
    // Para cambios de albarán en medio de un pedido en proceso
    $('#tablaAlbaranes').on('dblclick', function () {
        seleccionAlbaran();
        closeModal('#dialogLoV');
    });

    $('#seleccionarAlbaran').on("click", function () {
        seleccionAlbaran();
        closeModal('#dialogLoV');
    });

    $('#nuevoAlbaran').on("click", function () {
        datosAlbaran("", "", "");
        closeModal('#dialogLoV');
    });
}

function selectAlbaranPintarPed() {
    // Selección de albarán que añade los datos del pedido a la tabla
    $('#tablaAlbaranes').on('dblclick', function () {
        seleccionAlbaran();
        pintarTablaPedidos();
        closeModal('#dialogLoV');
    });

    $('#seleccionarAlbaran').on("click", function () {
        seleccionAlbaran();
        pintarTablaPedidos();
        closeModal('#dialogLoV');
    });

    $('#nuevoAlbaran').on("click", function () {
        datosAlbaran("", "", "");
        pintarTablaPedidos();
        closeModal('#dialogLoV');
    });
}

function datosAlbaran( tipoAlbaran, numAlbaran, fechaAlbaran) {
    // Recoge los datos del albaran y actualiza los datos en el menú
    $('#tipoAlbaran').val( tipoAlbaran);
    $('#numAlbaran').val( numAlbaran);
    $('#confirmar').prop('disabled', false);
    $('#dialogAlbaranes').modal('hide');
    v_fecha = fechaAlbaran === "" ? new Date() : new Date(fechaAlbaran);
    updateDatePicker(v_fecha);
    cambioAlbaran();
}

function seleccionAlbaran() {
    if ($('#tablaAlbaranes').DataTable().rows()[0].length > 0) {
        v_albaranSeleccionado = $('#tablaAlbaranes').DataTable().row('.selected').data();
        var v_albaran_seleccionado = $('#tablaAlbaranes').DataTable().rows('.selected').data()[0];
        var v_tipoAlbaran = v_albaran_seleccionado.GGALBTIP_COD;
        var v_numAlbaran = v_albaran_seleccionado.N_ALBARAN;
        var v_fechaAlbaran = v_albaran_seleccionado.F_ALBARAN_HID;
        datosAlbaran(v_tipoAlbaran, v_numAlbaran, v_fechaAlbaran);
        cambioAlbaran();
    }
}

function pintarTablaPedidos() {
    data = dataAux;

    // Clon de data para que los datos no sean modificados 
    // en el caso de que se cancele la operación
    v_dataClon = JSON.parse(JSON.stringify(data));

    initialize();
    generarMenu();

    var v_table = $('#tablaPedidos').DataTable();
    v_table.clear().draw();
    if (v_table.rows.length === 0) {
        v_table.rows.add(data.Lineas).draw();
        v_lineas = v_table.rows().data();
        selectRow('#tablaPedidos');
    }
    $('#menuObservaciones').show();

    $('#txtRefer').addClass('col-xs-10');
    $('#txtRefer').removeClass('col-xs-5');
    $('.sinLote').hide();

        $('#campRefer').val("").get(0).focus();
    // Si el pedido tiene alguna observación
    if (data.OBSER) {
        $('#menuObservaciones input').val(Resources.menu_show);
    } else {
        $('#menuObservaciones input').val(Resources.menu_no_observations);
    }

    // Si el albarán no es nuevo
    if (typeof v_albaranSeleccionado !== 'undefined') {
        var refAlb = v_albaranSeleccionado.SU_REF_ALB;
        $('#menuRefAlbaran input').val(refAlb);
        $('#codRefAlbaran').val(refAlb);
    }
    closeModal("#dialogAlbaranes");
}


function cambioAlbaran() {
    // Actualiza el menú desplegable con el albarán seleccionado
    if ($("#tipoAlbaran").val() !== "" && $("#numAlbaran").val() !== "") {
        v_albaran = $("#tipoAlbaran").val() + "-" + $("#numAlbaran").val();
    } else {
        v_albaran = Resources.menu_new;
    }
    $('#menuAlbaran div input').val(v_albaran);
}